<?php 
// application/helpers/geo_helper.php

defined('BASEPATH') OR exit('No direct script access allowed');

if (!function_exists('is_point_in_polygon')) {

    function is_point_in_polygon($point, $polygon) {
        $x = $point['longitude'];
        $y = $point['latitude'];

        $inside = false;
        $count = count($polygon);

        for ($i = 0, $j = $count - 1; $i < $count; $j = $i++) {
            $xi = $polygon[$i]['longitude'];
            $yi = $polygon[$i]['latitude'];
            $xj = $polygon[$j]['longitude'];
            $yj = $polygon[$j]['latitude'];

            $intersect = (($yi > $y) != ($yj > $y))
                && ($x < ($xj - $xi) * ($y - $yi) / ($yj - $yi) + $xi);
            if ($intersect) {
                $inside = !$inside;
            }
        }

        return $inside;
    }

}

?>