<?php
class Registermodel extends CI_Model
{


    /*---------- categories ------------*/

    public function common_fetch($table,$where)
	{
		$this->db->select()->from($table);
		$this->db->where($where);
		$this->db->order_by("id","desc");
		$qry=$this->db->get();
		return $qry->result();
	}
	
    // 	 /*common insert*/
    // function common_insert($table,$data)
    // {
    //     $this->db->insert($table,$data);
    //     $id = $this->db->insert_id();
    //     return $id;
    // } 
    // /*common insert */
    
    // /*common update */
    // function common_update($table,$data,$where)
    // {
    //     $this->db->where($where);
    //     $this->db->update($table,$data);
        
    //     return true;
    // }
    // /*common update */ 
    
    /*fetch rows*/
    public function get_rows($table,$where)
    {
        $this->db->select('*')->from($table);
        $this->db->where($where);
        $query= $this->db->get();
    	return $query->num_rows();
    }
    /*fetch rows*/
	



	public function get_manual_orders()
	{
		$this->db->select("mc.*,mu.*,sum(mc.price*mc.quantity) as total,db.name as db_name")->from("manual_cart mc");
		$this->db->where(array("order_id!="=>""));
		$this->db->join("products p","mc.product_id=p.id");
		$this->db->join("manual_users mu","mc.m_user_id=mu.id");
		$this->db->join("delivery_boys db","mc.db_id=db.id");
		$this->db->group_by("order_id");
		$this->db->order_by("mc.id","desc");
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_manual_orders_completed()
	{
		$this->db->select("mc.*,mu.*,sum(mc.price*mc.quantity) as total,db.name as db_name")->from("manual_cart mc");
		$this->db->where(array("mc.order_id!="=>""));
		$this->db->where(array("mc.db_status"=>"delivered"));
		$this->db->join("products p","mc.product_id=p.id");
		$this->db->join("manual_users mu","mc.m_user_id=mu.id");
		$this->db->join("delivery_boys db","mc.db_id=db.id");
		$this->db->group_by("order_id");
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_online_orders($table,$where)
	{
		$this->db->select("sum(total_amount) as total")->from($table);
		$this->db->where(array("payment_mode"=>"online"));
		$this->db->where($where);
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_offline_orders($table,$where)
	{
		$this->db->select("sum(total_amount) as total")->from("user_orders");
		$this->db->where(array("payment_mode"=>"offline"));
		$this->db->where($where);
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_online_orders_s($table,$where,$from_date,$to_date)
	{
		$this->db->select("sum(total_amount) as total")->from($table);
		$this->db->where(array("payment_mode"=>"online"));
		$this->db->where("added_on BETWEEN '$from_date' AND '$to_date'");
		$this->db->where($where);
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_offline_orders_s($table,$where,$from_date,$to_date)
	{
		$this->db->select("sum(total_amount) as total")->from("user_orders");
		$this->db->where(array("payment_mode"=>"offline"));
		$this->db->where($where);
		$this->db->where("added_on BETWEEN '$from_date' AND '$to_date'");
		$qry=$this->db->get();
		return $qry->result();
	}
	public function get_manual_order_details($order_id)
	{
		$this->db->select("mc.*,p.name as product_name,p.image as product_image,um.units as unts")->from("manual_cart mc");
		$this->db->where(array("order_id"=>$order_id));
		$this->db->join("products p","mc.product_id=p.id");
		$this->db->join("units_of_measures um","p.units=um.id");
		$qry=$this->db->get();
		return $qry->result();
	}
	function common_insert($table,$data)
	{
	    $this->db->insert($table,$data);
	    return $this->db->insert_id();
	}
	function db_search($table,$key)
	{
	     $this->db->select()->from($table);
	     $this->db->where("delete_status",1);
	   $this->db->like('name',$key);
	   $this->db->or_like('mobile',$key);
	   $this->db->where("delete_status",1);
	    $qry=$this->db->get();
		return $qry->result(); 
	}
	function pre_order_list()
	{
	    $this->db->select()->from("user_orders");
	    $this->db->where("schedule_date!=''");
	    $qry=$this->db->get();
		return $qry->result();
		
	}
	function common_update($table,$data,$where)
	{
	    $this->db->where($where);
	    $this->db->update($table,$data);
	    return true;
	}
	function common_delete($table,$where)
	{
	    $this->db->where($where);
	    $this->db->delete($table);
	}
	function get_subscriptions()
	{
	    $this->db->select()->from('subscriptions');
	    //$this->db->where();
	    $this->db->order_by("id","desc");
	    $qry=$this->db->get();
	    return $qry->result();
	}
	
	function get_subscriptions_new()
	{
	   // ,users.mobile_type,users.app_version,users.first_name.users.last_name,users.mobile
	   //,address.mobile as alternative_no,address.area_street,address.zipcode
	   // $this->db->select('*');
	    $this->db->select('subscriptions.*,users.mobile_type,users.app_version,users.first_name,users.last_name,users.mobile');
	    $this->db->from('subscriptions');
	    $this->db->join('users','users.id = subscriptions.user_id','left');
	   // $this->db->join('address','users.user_id = subscriptions.user_id','left');
	   // $this->db->where('address.default_address', 1);
	    $this->db->order_by("subscriptions.id","desc");
	    $qry=$this->db->get();
	    return $qry->result();
	}
	function get_subscriptions_ma($order_status,$date,$perpage,$limit)
	{
	    $this->db->select('subscription_orders.*,users.first_name,users.last_name,users.mobile,subscriptions.start_date,subscriptions.subscription_type,subscriptions.status as sub_status');
	    $this->db->from('subscription_orders');
	    $this->db->join('users','users.id = subscription_orders.user_id','left');
	    $this->db->join('subscriptions','subscriptions.order_id = subscription_orders.sub_id','left');
	    //$this->db->where("order_type","SUB");
	    //$this->db->where("schedule_date",date('Y-m-d 00:00:00'));
	   // $this->db->like("schedule_date",date("Y-m-d"));
	   
	   if(!empty($date)){
	       $this->db->where("subscription_orders.order_date",$date);
	   }
	   if(!empty($order_status)){
	       $this->db->where("subscription_orders.status",$order_status);
	   }
	    $this->db->order_by("subscription_orders.id","desc");
	    $this->db->limit($perpage,$limit);
	    $qry=$this->db->get();
	    return $qry->result();
	}
	
	function get_sub_order_details_order($sub_id)
	{
	    $this->db->select('subscription_cart.*,products.name,units_of_measures.units');
	    $this->db->from('subscription_cart');
	    $this->db->join('products','products.id = subscription_cart.product_id','left');
	    $this->db->join('units_of_measures','products.units = units_of_measures.id','left');
	    $this->db->where("subscription_cart.order_id",$sub_id);
	    //$this->db->where("subscription_cart.order_id",$sub_id);
	   // $this->db->order_by("subscription_cart.order_date","desc");
	    $qry=$this->db->get();
	    return $qry->result();
	}
	function get_subscription_items($order_id)
	{
	    $this->db->select()->from('subscription_cart');
	    $this->db->where("order_id",$order_id);
	    $this->db->where("status",2);
	    $this->db->order_by("order_date","desc");
	    $qry=$this->db->get();
	    return $qry->result();
	}
	
	function get_subscription_items_new($order_id)
	{
	    $this->db->select()->from('subscription_cart');
	    $this->db->where("order_id",$order_id);
	    $this->db->where("product_status",'subscribed');
	    $this->db->order_by("id","desc");
	    $qry=$this->db->get();
	    return $qry->result();
	}
	function get_about_us()
	{
	$this->db->select()->from('about_us');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
	function get_shipping_policy()
	{
	$this->db->select()->from('shipping_policy');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
	function get_payment_refund_policy()
	{
	    $this->db->select()->from('payment_refund_policy');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
	
	function get_inventory($from_date,$to_date)
	{
	$this->db->select('inventory.*,products.name as product_name')->from('inventory');
    $this->db->join('products','products.id = inventory.product_id');
    if(!empty($from_date) && !empty($to_date)){
        $this->db->where("date >=",$from_date);
        $this->db->where("date <=",$to_date);
    }
	//$this->db->where("boy_id",$bid);
	$qry=$this->db->get();
	return $qry->result();
	}
	function get_product_total_inventory_details($from_date,$to_date)
	{
	    $this->db->select('p.name as product_name,sum(i.quantity) as total_quantity, sum(i.instock) as total_instock,sum(i.damaged) as total_damaged,
	                 sum(i.sold) as total_sold, sum(i.b2b) as total_b2b');
	    $this->db->from('products p');
	    $this->db->join('inventory i','i.product_id = p.id','left');
	    $this->db->where('p.status',1);
	    if(!empty($from_date) && !empty($to_date)){
        $this->db->where("i.date >=",$from_date);
        $this->db->where("i.date <=",$to_date);
    }
	    $this->db->group_by('p.id');
	    $qry=$this->db->get();
	    return $qry->result();
	}
	function get_sales($bid)
	{
	$this->db->select('i.*,(select name from delivery_boys where id=i.boy_id)as boy')->from('boy_sales i');
	if(!empty($bid))
	{
	   $this->db->where("boy_id",$bid);    
	}
	$qry=$this->db->get();
	return $qry->result();
	}
	
	/*---------edit by sagar-----*/
	
	function get_db_total_sales($bid,$date)
	{
	      $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	    (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered") as total_sales,
	    (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered") as total_cod_sales,
	    (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered") as total_pod_sales,
	    (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered") as total_online_sales
	    ');
	    
	     $this->db->FROM('delivery_boys');
	   // $this->db->join('user_orders','delivery_boys.id = user_orders.db_id','left');
	    if(!empty($bid))
	    {
	      $this->db->where('delivery_boys.id',$bid);
	    }
	   
	    $this->db->where('delivery_boys.delete_status','1');
	    $qry=$this->db->get();
	   //echo $this->db->last_query();exit;
	    // echo $qry;exit;
	    
	    return $qry->result();
	  // echo $this->db->last_query();exit;
	}
	
	function get_db_sales($bid,$date)
	{
	   // if($date == '')
	    { 
	   // $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered") as total_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered") as total_cod_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered") as total_pod_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered") as total_online_sales
	   // ');
	    }if($date == 'today'){
	       // $date = date('Y-m-d');
	     $input = date('Y-m-d');
$date1 = date('Y-m-d 00:00:01', strtotime($input));
//echo $date1;exit;
	        //$time = '00:00:00';
	        
	   //    $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	   // (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered" AND cast(user_orders.delivered_on as Date) = '.$date.') as total_sales,
	   // (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered" AND cast(user_orders.delivered_on as Date) = '.$date.') as total_cod_sales,
	   // (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered" AND cast(user_orders.delivered_on as Date) = '.$date.') as total_pod_sales,
	   // (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered" AND cast(user_orders.delivered_on as Date) = '.$date.') as total_online_sales
	   // ');
	   
	    $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered" AND user_orders.delivered_on  >= "'.$date1.'") as total_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered" AND user_orders.delivered_on  >= "'.$date1.'") as total_cod_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered" AND user_orders.delivered_on  >= "'.$date1.'") as total_pod_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered" AND user_orders.delivered_on  >= "'.$date1.'") as total_online_sales,
	     (SELECT db_cod_payments.payment_status FROM db_cod_payments WHERE db_cod_payments.db_id = delivery_boys.id AND db_cod_payments.payment_date = "'.$date1.'") AS payment_cod_status
	    '); 
	    }
	   // if($date == 'month')
	    {
	   //     $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered" AND MONTH(user_orders.delivered_on) = MONTH(CURRENT_DATE())) as total_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered" AND MONTH(user_orders.delivered_on) = MONTH(CURRENT_DATE())) as total_cod_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered" AND MONTH(user_orders.delivered_on) = MONTH(CURRENT_DATE())) as total_pod_sales,
	   // (SELECT SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered" AND MONTH(user_orders.delivered_on) = MONTH(CURRENT_DATE())) as total_online_sales
	   // '); 
	    }
	    $this->db->FROM('delivery_boys');
	   // $this->db->join('user_orders','delivery_boys.id = user_orders.db_id','left');
	    if(!empty($bid))
	    {
	      $this->db->where('delivery_boys.id',$bid);
	    }
	   
	    $this->db->where('delivery_boys.delete_status','1');
	    $qry=$this->db->get();
	   //echo $this->db->last_query();exit;
	    // echo $qry;exit;
	    
	    return $qry->result();
	  // echo $this->db->last_query();exit;
	    
	}
	
	function get_db_sales_today($bid,$date)
	{
	    $this->db->select('
	    COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0)
	    ');
	    $this->db->FROM('user_orders');
	    $this->db->join('delivery_boys','delivery_boys.id = user_orders.db_id','left');
	    
	}
	function get_db_sales_month($bid,$date)
	{
	   // $input = date('Y-m-d');
//$date = date('Y-m-d h:i:s', strtotime($date));
//$date1 = date('Y-m-d 24:59:59', strtotime($date));
	 // echo $date;exit;
	  $date1 = date('Y-m-d 00:00:01', strtotime($date));
	  $date2 = date('Y-m-d 23:59:59', strtotime($date));
	     $this->db->select('delivery_boys.id,delivery_boys.name,delivery_boys.mobile,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.db_status = "delivered" AND user_orders.delivered_on >= "'.$date1.'" AND user_orders.delivered_on <= "'.$date2.'") as total_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "offline" AND user_orders.db_status = "delivered" AND user_orders.delivered_on >= "'.$date1.'" AND user_orders.delivered_on <= "'.$date2.'") as total_cod_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "pod" AND user_orders.db_status = "delivered" AND user_orders.delivered_on >= "'.$date1.'" AND user_orders.delivered_on <= "'.$date2.'") as total_pod_sales,
	    (SELECT COALESCE(SUM(user_orders.total_amount) + SUM(user_orders.delivery_charges) - SUM(user_orders.offer_amount) - SUM(user_orders.bonus_amount),0) FROM user_orders WHERE user_orders.db_id = delivery_boys.id AND user_orders.payment_mode = "online" AND user_orders.db_status = "delivered" AND user_orders.delivered_on >= "'.$date1.'" AND user_orders.delivered_on <= "'.$date2.'") as total_online_sales
	    '); 
	    $this->db->FROM('delivery_boys');
	   // $this->db->join('user_orders','delivery_boys.id = user_orders.db_id','left');
	    if(!empty($bid))
	    {
	      $this->db->where('delivery_boys.id',$bid);
	    }
	    $this->db->where('delivery_boys.delete_status','1');
	    $qry=$this->db->get();
	    return $qry->result();
	   //echo $this->db->last_query();exit;
	}
	
	/*---------edit by sagar-----*/
	public function delete_inventory($productid)
    {

     
        $this->db->where('id',$productid);
       $query= $this->db->delete('inventory');

     // $this->db->where('product_id',$productid);
      // $query_dis= $this->db->delete('cart');

       //$this->db->where('product_id',$productid);
       //$query_di= $this->db->delete('wishlist');
      
      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    public function delete_store($productid)
    {

     
        $this->db->where('id',$productid);
       $query= $this->db->delete('dark_stores');

     // $this->db->where('product_id',$productid);
      // $query_dis= $this->db->delete('cart');

       //$this->db->where('product_id',$productid);
       //$query_di= $this->db->delete('wishlist');
      
      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
	function get_terms()
	{
	$this->db->select()->from('terms');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
	function get_privacy()
	{
	$this->db->select()->from('privacy');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
	function get_contact_details()
	{
	$this->db->select()->from('contact_details');
	$this->db->where("id",1);
	$qry=$this->db->get();
	return $qry->result();
	}
    public function all_categories($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'category_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('categories.id')->from('categories')->where('categories.delete_status',1)->order_by('categories.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('categories.*,DATE_FORMAT(categories.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('categories')->where('categories.delete_status',1)->order_by('categories.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
       // echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function all_states($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'category_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('states.id')->from('states')->where('states.delete_status',1)->order_by('states.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('states.*,DATE_FORMAT(states.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(states.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('states')->where('states.delete_status',1)->order_by('states.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }
    
    public function delete_cities($categoryid)
    {

      

        $this->db->where('id',$categoryid);
       $query= $this->db->update('cities',array('delete_status'=>0));



      
       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    
    /*city management*/
     public function all_cities($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'category_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('cities.id')->from('cities')->where('cities.delete_status',1)->order_by('cities.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('cities.*,(select category_name from states where id=cities.state) as state,DATE_FORMAT(cities.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(cities.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('cities')->where('cities.delete_status',1)->order_by('cities.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }
    public function city_details($category)
    {   
        $this->db->where('delete_status',1);
        $this->db->like("replace(city, ' ', '')", "$category",'none');
       $query= $this->db->get('cities');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    public function get_cities($categoryid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$categoryid);
       $query= $this->db->get('cities');

       if($query)
       {
          return $query->row();
       }
       

    }
    /*city management*/
    function fetch_orders_all_orders($limit, $start)
{
    $this->db->select()->from("user_orders");
    //(!empty($state))?$this->db->where("state",$state):"";
    //(!empty($city))?$this->db->where("city",$city):"";
    //(!empty($area))?$this->db->like("area",$area,"both"):"";
   // (!empty($status))?$this->db->where("db_status",$status):"";
   $this->db->where('db_status !=','delivered');
  // $this->db->where('schedule_date',"0000-00-00 00:00:00");
   $this->db->limit($limit, $start);
    $this->db->order_by("id","desc");
		$qry=$this->db->get();
		return $qry->result();
    
}

function get_orders_count_search($state,$city,$area,$status)
{
     $this->db->select()->from("user_orders");
    (!empty($state))?$this->db->where("state",$state):"";
    (!empty($city))?$this->db->where("city",$city):"";
    (!empty($area))?$this->db->like("area",$area,"both"):"";
    (!empty($status))?$this->db->where("db_status",$status):"";
   // $this->db->limit($limit, $start);
    $this->db->order_by("id","desc");
		$qry=$this->db->get();
		return $qry->num_rows();
}

function search_orders($state,$city,$area,$status,$limit, $start)
{
    $this->db->select()->from("user_orders");
    (!empty($state))?$this->db->where("state",$state):"";
    (!empty($city))?$this->db->where("city",$city):"";
    (!empty($area))?$this->db->like("area",$area,"both"):"";
    (!empty($status))?$this->db->where("db_status",$status):"";
    $this->db->limit($limit, $start);
    $this->db->order_by("id","desc");
		$qry=$this->db->get();
		return $qry->result();
    
}

// function search_orders($state,$city,$area,$status)
// {
//     $this->db->select()->from("user_orders");
//     (!empty($state))?$this->db->where("state",$state):"";
//     (!empty($city))?$this->db->where("city",$city):"";
//     (!empty($area))?$this->db->like("area",$area,"both"):"";
//     (!empty($status))?$this->db->where("db_status",$status):"";
//     $this->db->order_by("id","desc");
// 		$qry=$this->db->get();
// 		return $qry->result();
    
// }

    public function delete_categories($categoryid)
    {

      $this->db->where('category',$categoryid);
      $query_products=$this->db->get('products');
       $products_details=$query_products->result_array();

        $this->db->where('id',$categoryid);
       $query= $this->db->update('categories',array('delete_status'=>0));


       $this->db->where('category',$categoryid);
       $query_products= $this->db->update('products',array('delete_status'=>0));

       $this->db->where('category',$categoryid);
       $query_sub_categories= $this->db->update('sub_categories',array('delete_status'=>0));

       foreach($products_details as $products_detail)
       {

       $this->db->where('product_id',$products_detail['id']);
       $query_dis= $this->db->update('cart',array('delete_status'=>0));

       $this->db->where('product_id',$products_detail['id']);
       $query_di= $this->db->update('wishlist',array('delete_status'=>0));

       }

      
       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }

    public function delete_states($categoryid)
    {

      

        $this->db->where('id',$categoryid);
       $query= $this->db->update('states',array('delete_status'=>0));



      
       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    
    public function get_categories($categoryid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$categoryid);
       $query= $this->db->get('categories');

       if($query)
       {
          return $query->row();
       }
       

    }
    public function get_states($categoryid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$categoryid);
       $query= $this->db->get('states');

       if($query)
       {
          return $query->row();
       }
       

    }
    public function category_details($category)
    {   
        $this->db->where('delete_status',1);
        $this->db->like("replace(category_name, ' ', '')", "$category",'none');
       $query= $this->db->get('categories');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    public function state_details($category)
    {   
        $this->db->where('delete_status',1);
        $this->db->like("replace(category_name, ' ', '')", "$category",'none');
       $query= $this->db->get('states');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    /*---------- /categories ------------*/
      public function delivery_charges_details($min_amount)
    {   
        $this->db->where('delete_status',1);
        $this->db->where("min_amount",$min_amount);
       $query= $this->db->get('delivery_charges');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    /*---------- subcategories ------------*/

    
    public function all_sub_categories($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'categories.category_name',
            2 => 'sub_categories.subcategory_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('sub_categories.id')->from('sub_categories')->join('categories','categories.id=sub_categories.category_id')->where('sub_categories.delete_status',1)->order_by('sub_categories.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('sub_categories.*,categories.category_name as category_name,DATE_FORMAT(sub_categories.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(sub_categories.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('sub_categories')->join('categories','categories.id=sub_categories.category_id')->where('sub_categories.delete_status',1)->order_by('sub_categories.id','desc');
            
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_sub_categories($subcategoryid)
    {

        $this->db->where('sub_category',$subcategoryid);
      $query_products=$this->db->get('products');
       $products_details=$query_products->result_array();



        $this->db->where('id',$subcategoryid);
       $query= $this->db->update('sub_categories',array('delete_status'=>0));

       $this->db->where('sub_category',$subcategoryid);
       $query_products= $this->db->update('products',array('delete_status'=>0));

      
      foreach($products_details as $products_detail)
       {

       $this->db->where('product_id',$products_detail['id']);
       $query_dis= $this->db->update('cart',array('delete_status'=>0));

       $this->db->where('product_id',$products_detail['id']);
       $query_di= $this->db->update('wishlist',array('delete_status'=>0));

       }

      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    public function total_categories()
    {   
        $this->db->order_by('category_name','asc');
        $this->db->where('delete_status',1);
        $query=$this->db->get('categories');
       if($query)
       {
          return $query->result();
       }
       else
       {
          return false;
       }

    }
     public function total_sub_categories()
    {   
        $this->db->where('delete_status',1);
        $query=$this->db->get('sub_categories');
       if($query)
       {
          return $query->result();
       }
       else
       {
          return false;
       }

    }
    public function total_sub_categories_multiple($category_id)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('category_id',$category_id);
        $query=$this->db->get('sub_categories');
       if($query)
       {
          return $query->result();
       }
       else
       {
          return false;
       }

    }
    public function get_sub_categories($subcategoryid)
    {
        $this->db->where('delete_status',1);
        $this->db->where('id',$subcategoryid);
       $query= $this->db->get('sub_categories');

       if($query)
       {
          return $query->row();
       }
       

    }
    public function sub_category_details($sub_category,$category_id)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('category_id',$category_id);
         $this->db->like("replace(subcategory_name, ' ', '')", "$sub_category",'none');
       $query= $this->db->get('sub_categories');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    /*---------- subcategories------------*/
       /*---------- units_of_measures ------------*/

    
    public function all_units_of_measures($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'units'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('units_of_measures.id')->from('units_of_measures')->where('units_of_measures.delete_status',1)->order_by('units_of_measures.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('units_of_measures.*,DATE_FORMAT(units_of_measures.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(units_of_measures.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('units_of_measures')->where('units_of_measures.delete_status',1)->order_by('units_of_measures.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_units_of_measures($units_of_measuresid)
    {


   
        $this->db->where('id',$units_of_measuresid);
       $query= $this->db->update('units_of_measures',array('delete_status'=>0));

      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_units_of_measures($units_of_measuresid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$units_of_measuresid);
       $query= $this->db->get('units_of_measures');

       if($query)
       {
          return $query->row();
       }
       

    }

    public function units_of_measures_details($units)
    {   
        $this->db->where('delete_status',1);
         $this->db->like("replace(units, ' ', '')", "$units",'none');
       $query= $this->db->get('units_of_measures');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    /*---------- /units_of_measures ------------*/
    /*---------- banks ------------*/

    
    public function all_banks($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'bank_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('banks.id')->from('banks')->where('banks.delete_status',1)->order_by('banks.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('banks.*,DATE_FORMAT(banks.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(banks.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('banks')->where('banks.delete_status',1)->order_by('banks.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_banks($banksid)
    {


      
      
       $this->db->where('id',$banksid);
       $query= $this->db->update('banks',array('delete_status'=>0));

       

       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_banks($banksid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$banksid);
       $query= $this->db->get('banks');

       if($query)
       {
          return $query->row();
       }
       

    }

    public function banks_details($banks)
    {   
        $this->db->where('delete_status',1);
          $this->db->like("replace(bank_name, ' ', '')", "$banks",'none');
       $query= $this->db->get('banks');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    /*---------- /banks ------------*/

        /*---------- offers------------*/
    public function all_offers($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'offer_name',
            2 => 'offer_type'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('offers.id')->from('offers')->where('offers.delete_status',1)->order_by('offers.id','desc')->get()->num_rows();
            
        }
        else
        {
            $this->db->select('offers.*,DATE_FORMAT(offers.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(offers.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on,,DATE_FORMAT(offers.valid_from_date,"%d-%m-%Y") as valid_from_date,DATE_FORMAT(offers.valid_to_date,"%d-%m-%Y") as valid_to_date')->from('offers')->where('offers.delete_status',1)->order_by('offers.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_offers($offerid)
    {


      $this->db->where('id',$offerid);
       $query= $this->db->update('offers',array('delete_status'=>0));

     
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_offers_add($offerid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$offerid);
       $query= $this->db->get('offers');

       if($query)
       {
          return $query->row();
       }
       

    }

 public function offer_details($offer)
    {   

        $this->db->where('delete_status',1);
        $this->db->like("replace(offer_name, ' ', '')", "$offer",'none');
       $query= $this->db->get('offers');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
     /*---------- offers------------*/
         /*----------amount_calculations------------*/

    
    public function all_amount_calculations($pdata, $getcount=null)
    {
        $search_1 = array
        (
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('amount_calculations.id')->from('amount_calculations')->where('amount_calculations.delete_status',1)->order_by('amount_calculations.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('amount_calculations.*,DATE_FORMAT(amount_calculations.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(amount_calculations.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('amount_calculations')->where('amount_calculations.delete_status',1)->order_by('amount_calculations.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    
    public function get_amount_calculations($amount_calculationsid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$amount_calculationsid);
       $query= $this->db->get('amount_calculations');

       if($query)
       {
          return $query->row();
       }
       

    }

    /*---------- /amount_calculations ------------*/
   
     /*---------- product banners ------------*/

    
    public function all_product_banners($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'description'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('product_banners.id')->from('product_banners')->where('product_banners.delete_status',1)->order_by('product_banners.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('product_banners.*,DATE_FORMAT(product_banners.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,
            DATE_FORMAT(product_banners.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on,
            (SELECT categories.category_name FROM categories WHERE categories.id = product_banners.category_id) category_name,
            (SELECT sub_categories.subcategory_name FROM sub_categories WHERE sub_categories.id = product_banners.sub_category_id) subcategory_name,
            (SELECT products.name FROM products WHERE products.id = product_banners.product_id) product_name')->from('product_banners')->where('product_banners.delete_status',1)->order_by('product_banners.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_product_banners($pbid)
    {

      
        $this->db->where('id',$pbid);
       $query= $this->db->update('product_banners',array('delete_status'=>0));

       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_product_banners($banner_id)
    {   
        $this->db->where('product_banners.delete_status',1);
        $this->db->where('product_banners.id',$banner_id);
        $this->db->join('categories','categories.id = product_banners.category_id','left');
        $this->db->join('sub_categories','sub_categories.id = product_banners.sub_category_id','left');
        $this->db->join('products','products.id = product_banners.product_id','left');
        $this->db->from('product_banners')->select('product_banners.*,products.name as product_name,sub_categories.subcategory_name,categories.category_name');
       $query= $this->db->get();

       if($query)
       {
          return $query->row();
       }
       

    }

    /*---------- Product Banners ------------*/
     /*----------referral_amount------------*/

    
    public function all_referral_amount($pdata, $getcount=null)
    {
        $search_1 = array
        (
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('referral_amount.id')->from('referral_amount')->where('referral_amount.delete_status',1)->order_by('referral_amount.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('referral_amount.*,DATE_FORMAT(referral_amount.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(referral_amount.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('referral_amount')->where('referral_amount.delete_status',1)->order_by('referral_amount.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    
    public function get_referral_amount($referral_amountid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$referral_amountid);
       $query= $this->db->get('referral_amount');

       if($query)
       {
          return $query->row();
       }
       

    }

    /*---------- /referral_amount ------------*/
    /*---------- time_slots ------------*/

    
    public function all_time_slots($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'from_time',
            2 => 'to_time'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('time_slots.id')->from('time_slots')->where('time_slots.delete_status',1)->order_by('time_slots.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('time_slots.*,DATE_FORMAT(time_slots.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(time_slots.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('time_slots')->where('time_slots.delete_status',1)->order_by('time_slots.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_time_slots($time_slotsid)
    {


      
      
       $this->db->where('id',$time_slotsid);
       $query= $this->db->update('time_slots',array('delete_status'=>0));

       

       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_time_slots($time_slotsid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$time_slotsid);
       $query= $this->db->get('time_slots');

       if($query)
       {
          return $query->row();
       }
       

    }

    public function time_slots_details($time_slots_check_1,$time_slots_check_2)
    {   
        $this->db->where('delete_status',1);
        $this->db->like("replace(from_time, ' ', '')", "$time_slots_check_1",'none');
        $this->db->like("replace(to_time, ' ', '')", "$time_slots_check_2",'none');
       $query= $this->db->get('time_slots');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
    /*---------- /time_slots ------------*/
     /*----------delivery_boys ------------*/

    
    public function all_delivery_boys($pdata, $getcount=null)
    {
        $search_1 = array
        (
             1 => 'delivery_boys.id',
            2 => 'delivery_boys.name',
            3=> 'delivery_boys.mobile',
            4 => 'delivery_boys.email_id'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            // return $this->db->select('delivery_boys.id')->from('delivery_boys')->where('delivery_boys.delete_status',1)->order_by('delivery_boys.id','desc')->get()->num_rows();
            return $this->db->select('delivery_boys.id')->from('delivery_boys')->order_by('delivery_boys.id','desc')->get()->num_rows();
        }
        else
        {
           
            //  $this->db->select('delivery_boys.*,DATE_FORMAT(delivery_boys.created_on,"%d-%m-%Y:%H:%i:%s") as created_on')->from('delivery_boys')->where('delivery_boys.delete_status',1)->order_by('delivery_boys.id','desc');
              $this->db->select('delivery_boys.*,DATE_FORMAT(delivery_boys.created_on,"%d-%m-%Y:%H:%i:%s") as created_on')->from('delivery_boys')->order_by('delivery_boys.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function get_delivery_boys_details($id)
    {

       $this->db->where('delete_status',1);
       $this->db->where('id',$id);
       $query= $this->db->get('delivery_boys');
       // echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->row();
       }
       else
       {
          return false;
       }

    }
    public function delete_delivery_boys()
    {        
        
        $this->db->where('id', $this->uri->segment(4));
        $this->db->update('delivery_boys', array('delete_status'=>0)); 
        // echo $this->db->last_query();exit;               
        return true;
    }

      public function change_delivery_boys_bstatus($delivery_boys_id, $status)
    {        
        $this->db->where('id', $delivery_boys_id);
        $this->db->update('delivery_boys', array('block_status' => $status));
        //echo $this->db->last_query();exit;
                  
        return true;
    }
    
      public function change_delivery_boys_approvestatus($delivery_boys_id, $status)
    {        
        $this->db->where('id', $delivery_boys_id);
        $this->db->update('delivery_boys', array('block_status' => $status,'status' => $status,'delete_status' => $status));
        //echo $this->db->last_query();exit;
                  
        return true;
    }
        public function change_delivery_boys_deltestatus($delivery_boys_id, $status)
    {        
        $this->db->where('id', $delivery_boys_id);
        //echo $this->db->last_query();exit;
        $this->db->delete("delivery_boys");
        return true;   
    }
     public function change_delivery_boys_status($delivery_boys_id, $status)
    {        
        $this->db->where('id', $delivery_boys_id);
        $this->db->update('delivery_boys', array('status' => $status));
        //echo $this->db->last_query();exit;
                  
        return true;
    }
    public function get_bank_details($id)
    {        
       $this->db->where('db_bank_details.delete_status',1);
        $this->db->where('db_bank_details.db_id', $id);
        $this->db->join('banks','banks.id=db_bank_details.bank_id');
       $query= $this->db->get('db_bank_details');
        //echo $this->db->last_query();exit;
         if($query) 
         {
           return $query->row();

         }     
         else
         {
           return False; 
         }
    }
    
    public function get_db_all_details($db_id)
    {
        $this->db->select('delivery_boys.*');
        $this->db->from('delivery_boys');
       // $this->db->join('dark_stores','dark_stores.id = delivery_boys.store_id');
        $this->db->where('delivery_boys.id',$db_id);
        $query = $this->db->get();
        return $query->result();
    }
        public function get_db_details($db_id)
    {        
        
        $this->db->where('delete_status',1);
        $this->db->where('id', $db_id);
       $query= $this->db->get('delivery_boys');
        //echo $this->db->last_query();exit;
         if($query) 
         {
           return $query->row();

         }     
         else
         {
           return False; 
         }
    }

    public function insert_db_notifications($data)
    {        
       
     $this->db->insert('notifications',$data);
      return true;
    }
    /*---------- delivery_boys ------------*/
      /*---------- db help ------------*/

    
    public function all_db_help($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'delivery_boys.id',
            2 => 'delivery_boys.name',
            3 => 'delivery_boys.mobile'

        );        
        if(isset($pdata['search_text_1'])!="")
        {
          
                $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] );
            

        }
        if($getcount)
        {
            return $this->db->select('db_help.id')->from('db_help')->join('delivery_boys','delivery_boys.id=db_help.db_id')->where('db_help.delete_status',1)->order_by('db_help.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('db_help.*,DATE_FORMAT(db_help.posted_on,"%d-%m-%Y:%H:%i:%s") as posted_on,delivery_boys.name as name,delivery_boys.mobile as mobile')->from('db_help')->join('delivery_boys','delivery_boys.id=db_help.db_id')->where('db_help.delete_status',1)->order_by('db_help.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_db_help($db_helpid)
    {


   
        $this->db->where('id',$db_helpid);
       $query= $this->db->update('db_help',array('delete_status'=>0));

      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    /*---------- db_help ------------*/
    /*----------users ------------*/

    
    public function all_users($pdata, $getcount=null)
    {
        $search_1 = array
        (
             1 => 'users.id',
            2 => 'users.name',
            3=> 'users.mobile',
            4 => 'users.email_id'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('users.id')->from('users')->where('users.delete_status',1)->order_by('users.id','desc')->get()->num_rows();
        //   $this->db->select('users.id');
        //      $this->db->from('users');
        //      $this->db->join('addresses','addresses.user_id = users.id','left');
        //      //$this->db->join('draw_coupons','draw_coupons.user_id = users.id','left');
        //      $this->db->where('users.delete_status',1);
        //     // $this->db->where('addresses.default_address',1);
        //   //   $this->db->order_by('users.id','desc');
        //     return $this->db->get()->num_rows();
        }
        else
        {
           
            // $this->db->select('users.*, DATE_FORMAT(users.created_on,"%d-%m-%Y:%H:%i:%s") as created_on')->from('users')->where('users.delete_status',1)->order_by('users.id','desc');
             
            $a =  $this->db->select('users.*,IFNULL(users.mobile_type, "unknown") AS mobile_type,IFNULL(users.app_version, "unknown") AS app_version,(SELECT addresses.mobile FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 LIMIT 0,1) alternative_number,
                                        (SELECT addresses.zipcode FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 LIMIT 0,1) zipcode,
                                        (SELECT addresses.area_street FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 LIMIT 0,1) area_street,
                                        (SELECT addresses.property_name FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 LIMIT 0,1) property_name,
                                        (SELECT addresses.block_number FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 LIMIT 0,1) block_number,
          
             (SELECT COUNT(draw_coupons.user_id) FROM draw_coupons WHERE draw_coupons.user_id = users.id) ld_coupons_used,
             (SELECT COUNT(users.id) FROM users WHERE users.referred_by = users.referral_code) referral_count,
             (SELECT COUNT(addresses.id) FROM addresses WHERE addresses.user_id = users.id AND addresses.delete_status = 1) addresses_count,
             users.mobile as primary_number, DATE_FORMAT(users.created_on,"%d-%m-%Y:%H:%i:%s") as created_on
             ');
            //  echo '<pre>';
            //  print_r($a);exit;
             $this->db->from('users');
            // $this->db->join('addresses','addresses.user_id = users.id','left');(SELECT CONCAT(addresses.mobile,"-",addresses.zipcode,"-",addresses.area_street,"-",addresses.property_name,"-",addresses.block_number)  FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1) A ,
             //$this->db->join('draw_coupons','draw_coupons.user_id = users.id','left');
             $this->db->where('users.delete_status',1);
             //$this->db->where('addresses.default_address',1);
             $this->db->order_by('users.id','desc');
             
             
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        
        $result = $this->db->get()->result_array();
    //   echo $this->db->last_query();exit;
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
        
    //     $query = $this->db->get();
    //             $result = array();
    //      if($query !== FALSE && $query->num_rows() > 0){
    //          foreach ($query->result_array() as $row) {
    //             $data[] = $row;
                
    //         }
    //      }
         
    //      foreach($result as $key=>$values)
    //     {
    //         $result[$key]['sno'] = $generatesno++;
    //     }
    // //echo $this->db->last_query();exit;
    //     return $result;
    }

    public function get_user_details($id)
    {

       $this->db->where('delete_status',1);
       $this->db->where('id',$id);
       $query= $this->db->get('users');
       // echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->row();
       }
       else
       {
          return false;
       }

    }
    public function delete_users()
    {        
        
        $this->db->where('id', $this->uri->segment(4));
        $this->db->update('users', array('delete_status'=>0)); 
        // echo $this->db->last_query();exit;               
        return true;
    }

      public function change_users_bstatus($users_id, $status)
    {        
        $this->db->where('id', $users_id);
        $this->db->update('users', array('block_status' => $status));
        //echo $this->db->last_query();exit;
                  
        return true;
    }
     
    public function get_address_list_details($id)
    {    // echo $id;exit; 'CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as addresses' 
    
        // $this->db->select("CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected");
        //   $this->db->from('addresses');
        $this->db->select('CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as addresses')->from('addresses')->where('addresses.delete_status',1)->where('addresses.user_id', $id);
      $this->db->order_by('addresses.id','asc');
       $query= $this->db->get();
        // echo $this->db->last_query();exit;
         if($query) 
         {
           return $query->result_array();

         }     
         else
         {
           return False; 
         }
    }
        public function get_referral_users_details($user_id)
    {        
        
       
          $final=array();
      
              $this->db->where('users.delete_status',1);
              $this->db->where('users.id',$user_id);
              $this->db->from('users');  
              $this->db->select('users.*');     
              $user_data=$this->db->get()->row_array();
              // var_dump($query);
              // exit;
              $this->db->where('users.delete_status',1);
              $this->db->where('referred_by',$user_data['referral_code']);
              $this->db->from('users');  
              $this->db->select('users.*');     
              $query=$this->db->get()->result_array();

            for ($i=0; $i < sizeof($query) ; $i++) 
               {           
               
              $this->db->where('users.delete_status',1);
              $this->db->where('users.id',$query[$i]['id']);
              $this->db->from('users');  
              $this->db->select('users.id,users.name,amount_to_referred_by as referral_amount,users.profile_image as profile_image,users.mobile as mobile');     
              $user_data_s=$this->db->get()->row_array();
              // $referral_amount = get_table_row('referral_amount', array('delete_status'=>1));
              // $user_data_s['referral_amount']=$referral_amount['referral_amount'];

               $final[]=$user_data_s;
         
    
              // if(!empty($products))
              // {
              //   $fin[]=$final;
              // }
             }
  
   return $final;
    }

    public function insert_user_notifications($data)
    {        
       
     $this->db->insert('notifications',$data);
      return true;
    }
    /*---------- users ------------*/
    /*---------- user help ------------*/

    
    public function all_user_help($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'users.id',
            2 => 'users.name',
            3 => 'users.mobile'

        );        
        if(isset($pdata['search_text_1'])!="")
        {
          
                $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] );
            

        }
        if($getcount)
        {
            return $this->db->select('user_help.id')->from('user_help')->join('users','users.id=user_help.user_id')->where('user_help.delete_status',1)->order_by('user_help.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('user_help.*,DATE_FORMAT(user_help.posted_on,"%d-%m-%Y:%H:%i:%s") as posted_on,users.first_name as name,users.mobile as mobile')->from('user_help')->join('users','users.id=user_help.user_id')->where('user_help.delete_status',1)->order_by('user_help.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    public function delete_user_help($user_helpid)
    {


   
        $this->db->where('id',$user_helpid);
       $query= $this->db->update('user_help',array('delete_status'=>0));

      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    /*---------- user_help ------------*/
   
    /*---------- /user bulk notifications ------------*/ 

    public function all_user_bulk_notifications($pdata, $getcount=null)
    {        
        $search_1 = array
        (
            1 => 'notification'
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            
          
            return $this->db->select('notifications.id')->from('notifications')->where('notifications.user_type','user')->group_by('notification')->order_by('notifications.id','desc')->get()->num_rows();  
        }
        else
        {
          
          $this->db->select('notifications.*,DATE_FORMAT(notifications.created_on,"%d-%m-%Y:%H:%i:%s") as created_on')->from('notifications')->where('notifications.user_type','user')->group_by('notification')->order_by('notifications.id','desc');

        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }   
   public function get_user_ids()
    {
        
        $userids = array(); 
        $this->db->where('users.delete_status',1);
        $this->db->where('users.block_status',1);
        $records_s = $this->db->get('users');
        $res_s = $records_s->result_array();
      
        foreach($res_s as $row_s)
      {
          $userids[] = $row_s['id'];
      }

      return $userids;
        
    }
   
 /*--------------------------user bulk notifications ------------*/ 
      /*----------------------------- /jobseeker bulk notifications ------------*/ 



    public function all_db_bulk_notifications($pdata, $getcount=null)
    {        
        $search_1 = array
        (
            1 => 'notification',
            
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            
          
            return $this->db->select('notifications.id')->from('notifications')->where('notifications.user_type','db')->group_by('notification')->order_by('notifications.id','desc')->get()->num_rows();  
        }
        else
        {
          
          $this->db->select('notifications.*,DATE_FORMAT(notifications.created_on,"%d-%m-%Y:%H:%i:%s") as created_on')->group_by('notification')->from('notifications')->where('notifications.user_type','db')->order_by('notifications.id','desc');

        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }   
     public function get_db_ids()
    {
        
        $dbids = array(); 
        $this->db->where('delivery_boys.delete_status',1);
        $this->db->where('delivery_boys.block_status',1);
        $records_s = $this->db->get('delivery_boys');
        $res_s = $records_s->result_array();
      
        foreach($res_s as $row_s)
      {
          $dbids[] = $row_s['id'];
      }

      return $dbids;
        
    }
/*---------- /db bulk notifications ------------*/ 
     /*---------- products------------*/
    public function all_products($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'products.product_name',
            2 => 'categories.category_name',
            3 => 'sub_categories.subcategory_name'
        );        
       
          if(isset($pdata['search_text_1'])!="")
        {
          if($pdata['search_on_1'] != 4)
            {
               $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] );
            }
             
        }
        if(isset($pdata['search_text_2'])!="")
        { 
            
            if(($pdata['search_on_1'] == 4)&&($pdata['search_text_2']!=''))
            {
                $s1date=date('Y-m-d', strtotime($pdata['search_text_2']));
                $s2date = date('Y-m-d', strtotime($pdata['search_text_3']));
                  
               $this->db->where("DATE_FORMAT(products.expiry_date,'%Y-%m-%d') >=", $s1date);
              $this->db->where("DATE_FORMAT(products.expiry_date,'%Y-%m-%d') <=", $s2date);
            }
        }
        if($getcount)
        {
            return $this->db->select('products.id')->from('products_new')->join('categories','categories.id=products.category_id')->join('units_of_measures','units_of_measures.id=products.units')->join('sub_categories','sub_categories.id=products.sub_category_id')->where('products.product_type','individual')->where('products.delete_status',1)->order_by('products.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('products.*,categories.category_name as category_name,units_of_measures.units,DATE_FORMAT(products.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(products.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on,sub_categories.subcategory_name as subcategory_name,DATE_FORMAT(products.expiry_date,"%d-%m-%Y") as expiry_date')->from('products')->join('categories','categories.id=products.category_id')->join('units_of_measures','units_of_measures.id=products.units')->join('sub_categories','sub_categories.id=products.sub_category_id')->where('products.product_type','individual')->where('products.delete_status',1)->order_by('products.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }

    // public function delete_products($productid)
    // {

     
    //     $this->db->where('id',$productid);
    //   $query= $this->db->update('products',array('delete_status'=>0));

    //   $this->db->where('product_id',$productid);
    //   $query_dis= $this->db->update('cart',array('delete_status'=>0));

    //   $this->db->where('product_id',$productid);
    //   $query_di= $this->db->update('wishlist',array('delete_status'=>0));
      
      
    //   if($query)
    //   {
    //       return true;
    //   }
    //   else
    //   {
    //       return false;
    //   }

    // }
     public function delete_products($productid)
    {

     
    //     $this->db->where('id',$productid);
    //   $query= $this->db->delete('products');

    //   $this->db->where('product_id',$productid);
    //   $query_dis= $this->db->delete('cart');

    //   $this->db->where('product_id',$productid);
    //   $query_di= $this->db->delete('wishlist');
      
      
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    

    public function get_products($productid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$productid);
       $query= $this->db->get('products');

       if($query)
       {
          return $query->row();
       }
       

    }
    public function get_products_list()
    {   
       $this->db->select('p.*,c.category_name')->from('products p');
        //$this->db->where('p.delete_status',1);
        $this->db->join('categories c','c.id=p.category');
    //    $this->db->join('sub_categories sc','sc.id=p.sub_category');
        $this->db->order_by("id","desc");
       $query= $this->db->get();

       if($query)
       {
          return $query->result();
       }
       

    }
    public function get_products_list_search($key)
    {   
       $this->db->select('p.*,c.category_name')->from('products p');
      //  $this->db->where('p.delete_status',1);
        $this->db->like("p.name",$key,"both");
        $this->db->join('categories c','c.id=p.category');
      //  $this->db->join('sub_categories sc','sc.id=p.sub_category');
        $this->db->order_by("id","desc");
       $query= $this->db->get();

       if($query)
       {
          return $query->result();
       }
       

    }
    public function get_combo_products_list()
    {   
       $this->db->select('p.*,c.category_name,sc.subcategory_name')->from('products p');
        $this->db->where('p.delete_status',1);
        $this->db->where('product_type',"combo");
        $this->db->join('categories c','c.id=p.category');
        $this->db->join('sub_categories sc','sc.id=p.sub_category');
       $query= $this->db->get();

       if($query)
       {
          return $query->result();
       }
       

    }

    public function categories()
    {   
       //$this->db->order_by('category_name','asc');
        $this->db->where('delete_status',1);
       $query= $this->db->get('categories');

       if($query->num_rows()>0)
       {
          return $query->result_array();
       }
       

    }
   public function subcategories($category_id)
    {   
       $this->db->order_by('subcategory_name','asc');
        $this->db->where('delete_status',1);
        $this->db->where('category_id',$category_id);
       $query= $this->db->get('sub_categories');

       if($query->num_rows()>0)
       {
          return $query->result_array();
       }
       

    }

public function units()
    {   
        $this->db->where('delete_status',1);
        $this->db->order_by('units','asc');
       $query= $this->db->get('units_of_measures');

       if($query)
       {
          return $query->result_array();
       }
       

    }
    public function city_ajax($state)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('state',$state);
        //$this->db->order_by('units','asc');
       $query= $this->db->get('cities');

       if($query)
       {
          return $query->result_array();
       }
       

    }
    public function stores_ajax($city)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('city',$city);
        //$this->db->order_by('units','asc');
       $query= $this->db->get('dark_stores');

       if($query)
       {
          return $query->result_array();
       }
       

    }
    public function get_dbs_by_store_ids($city)
    {   
        $in=explode(",",$city);
        $this->db->where('delete_status',1);
        $this->db->where_in('store_id', $in);
        //$this->db->where('city',$city);
        //$this->db->order_by('units','asc');
       $query= $this->db->get('delivery_boys');

       if($query)
       {
          return $query->result_array();
       }
       

    }
    
 public function get_pro_category_sub($category_id)
    {   
         $this->db->order_by('subcategory_name','asc');
        $this->db->where('delete_status',1);
        $this->db->where('category_id',$category_id);
       $query= $this->db->get('sub_categories');

       if($query)
       {
          return $query->result_array();
       }
       

    }
    
    public function get_sub_cat_product_id($sub_cat_id)
    {
        $this->db->order_by('name','asc');
        $this->db->where('delete_status',1);
        $this->db->where('sub_category',$sub_cat_id);
       $query= $this->db->get('products');

       if($query)
       {
          return $query->result_array();
       }
    }
       /*---------- products------------*/
       /*---------- combo products------------*/
        public function all_combo_products($pdata, $getcount=null)
    {
        $search_1 = array
        (  
            1=> 'products.product_name'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('products.id')->from('products')->where('products.product_type','combo')->where('products.delete_status',1)->order_by('products.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('products.*,DATE_FORMAT(products.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(products.modified_on,"%d-%m-%Y:%H:%i:%s") as modified_on')->from('products')->where('products.product_type','combo')->where('products.delete_status',1)->order_by('products.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }
   
     public function delete_combo_products($combo_productid)
    {

     
        $this->db->where('id',$combo_productid);
       $query= $this->db->update('products',array('delete_status'=>0));
      
       $this->db->where('product_id',$combo_productid);
       $query_pd= $this->db->update('combo_sub_products',array('delete_status'=>0));

      $this->db->where('product_id',$combo_productid);
       $query_cart= $this->db->update('cart',array('delete_status'=>0));

       $this->db->where('product_id',$combo_productid);
       $query_wishlist= $this->db->update('wishlist',array('delete_status'=>0));
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_combo_products($combo_productid)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$combo_productid);
       $query= $this->db->get('products');

       if($query)
       {
          return $query->row();
       }
       

    }

   
    
    public function combo_sub_products($combo_productid)
    {   
        
        $this->db->where('delete_status',1);
        $this->db->where('product_id',$combo_productid);
       $query= $this->db->get('combo_sub_products');

       if($query)
       {
          return $query->result_array();
       }
       
       

    }
    public function delete_combo_sub_products($id)
    {   
     
       
       $this->db->where('delete_status',1);
        $this->db->where('id',$id);
       $query= $this->db->get('combo_sub_products');

       if($query)
       {  
          $a=$query->result_array();
          
       }

       $this->db->where('delete_status',1);
       $this->db->where('product_id',$a[0]['product_id']);
       $query_b= $this->db->get('combo_sub_products');

       if($query_b)
       {  
          
          $count=$query_b->num_rows();
       }

      
        if($count>=2)
        {
           $this->db->where('id',$id);
          $query_c= $this->db->update('combo_sub_products',array('delete_status'=>0));
          return true;
        }
       
       else
       {
          return false;
       }

    }
    public function get_view_combo_sub_product_details($id)
    {   
     
       
       $this->db->where('combo_sub_products.delete_status',1);
       $this->db->where('combo_sub_products.product_id',$id);
       $this->db->join('units_of_measures','units_of_measures.id=combo_sub_products.units');
       $this->db->from('combo_sub_products');
       $this->db->select('combo_sub_products.*,units_of_measures.units as units,DATE_FORMAT(combo_sub_products.expiry_date,"%d-%m-%Y") as expiry');
       $query= $this->db->get();
      // echo $this->db->last_query();
      // exit;
       if($query)
       {  
          return $query->result_array();
          
       }
    }
    public function get_view_combo_products($id)
    {   
     
       
       $this->db->where('products.delete_status',1);
       $this->db->where('products.id',$id);
       $this->db->where('products.product_type','combo');
       $this->db->from('products');
       $this->db->select('products.*');
       $query= $this->db->get();
      // echo $this->db->last_query();
      // exit;
       if($query)
       {  
          return $query->row();
          
       }
    }
    
     /*---------- combo products------------*/
     /*---------- New Orders ------------*/

    
    // public function all_new_orders($pdata, $getcount=null)
    // {
    //     $search_1 = array
    //     (
    //         1 => 'user_ordertrackhistory.unique_order_id',
    //         2 => 'user_ordertrackhistory.user_id',
    //         3 => 'users.mobile',
    //         4 => 'user_ordertrackhistory.deliveryboy_status',
    //         5 => 'user_ordertrackhistory.status'
            
    //     );        
    //     if(isset($pdata['search_text_1'])!="")
    //     {
    //       if($pdata['search_on_1'] != 5)
    //         {
    //         $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
    //       }
    //     }
    //      if(isset($pdata['search_text_2'])!="")
    //     { 
            
    //         if(($pdata['search_on_1'] == 5)&&($pdata['search_text_2']!=''))
    //         {
    //             $s1date=date('Y-m-d', strtotime($pdata['search_text_2']));
    //             $s2date = date('Y-m-d', strtotime($pdata['search_text_3']));
                  
    //           $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') >=", $s1date);
    //           $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') <=", $s2date);
    //         }
    //     }
    //     if($getcount)
    //     {
    //         return $this->db->select('user_ordertrackhistory.id')->from('user_ordertrackhistory')->join('users','users.id=user_ordertrackhistory.user_id')->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id')->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left')->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id')->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id')->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE)->group_by('user_orders.unique_order_id')->order_by('user_orders.id','desc')->get()->num_rows();
    //     }
    //     else
    //     {
    //         $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_ordertrackhistory.total_amount as subtotalprice,user_orders.qty,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile');
    //         // ,time_slots.from_time as from_time,time_slots.to_time as to_time');
    //         $this->db->from('user_ordertrackhistory');
    //         $this->db->join('users','users.id=user_ordertrackhistory.user_id');
    //         $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
    //         $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
    //         $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
    //         // $this->db->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id');
            
    //         $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
    //         $this->db->group_by('user_orders.unique_order_id');
    //         $this->db->order_by('user_orders.id','desc');
    //         //  $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile');
    //         //     $this->db->from('user_ordertrackhistory');
    //         //     $this->db->join('users','users.id=user_ordertrackhistory.user_id');
    //         //     $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
    //         //     $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
    //         //     $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
    //         //     $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
    //         //     $this->db->order_by('user_orders.order_taken_on','desc');
    //     }
    //     if(isset($pdata['length']))
    //     {
    //         $perpage = $pdata['length'];
    //         $limit = $pdata['start'];
    //         $generatesno=$limit+1;
    //         $this->db->limit($perpage,$limit);
    //     }
    //     else
    //     {
    //         $generatesno = 0;
    //     }
    //     $result = $this->db->get()->result_array();//echo "12<pre>";print_r($result);exit;
      
    //     $datres=array();
    //     foreach($result as $row){
    //         $this->db->select(array("unique_order_id","total_amount"));
    //         $this->db->where("unique_order_id",$row['unique_order_id']);
    //          $this->db->from('user_orders');
    //           $result1 = $this->db->get()->result_array();
    //             $subtotal=0;
    //             foreach($result1 as $row3){
    //                 $subtotal=$subtotal+$row3['total_amount'];
    //             }
    //             $sub=array("subtotal"=>$subtotal);
    //             $payableamt=$subtotal+$row['delivery_charges']-$row['offer_amount']-$row['referral_amount_used'];
    //             $finalamt=array("final_amt"=>$payableamt);
    //          $res=array_merge($sub,$row,$finalamt);
    //          array_push($datres,$res);
             
    //     }
    //     $allresnopre=array();
    //       $allrespre=array();
    //     foreach($datres as $row){
    //         if($row['preorder'] ==0){
    //              $this->db->select("time_slots.from_time as from_time,time_slots.to_time as to_time");
    //         $this->db->where("id",$row['time_slot_id']);
    //          $this->db->from('time_slots');
    //           $result_time = $this->db->get()->row_array();
    //           $finalslot=array("time_slot_no_pre"=>$result_time);
    //          $res=array_merge($row,$result_time);
    //          array_push($allresnopre,$res);
    //         }
    //          if($row['preorder'] ==1){
    //              array_push($allrespre,$row);
    //          }
    //     }
        
    //       $allres=array_merge($allresnopre,$allrespre);
    //     foreach($allres as $key=>$values)
    //     {
    //         $allres[$key]['sno'] = $generatesno++;
    //     }
    //     return $allres;
    // }
    public function all_new_orders($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'user_ordertrackhistory.unique_order_id',
            2 => 'user_ordertrackhistory.user_id',
            3 => 'users.mobile',
            4 => 'user_ordertrackhistory.deliveryboy_status',
            5 => 'user_ordertrackhistory.status'
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
          if($pdata['search_on_1'] != 5)
            {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
          }
        }
         if(isset($pdata['search_text_2'])!="")
        { 
            
            if(($pdata['search_on_1'] == 5)&&($pdata['search_text_2']!=''))
            {
                $s1date=date('Y-m-d', strtotime($pdata['search_text_2']));
                $s2date = date('Y-m-d', strtotime($pdata['search_text_3']));
                  
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') >=", $s1date);
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') <=", $s2date);
            }
        }
        if($getcount)
        {
            return $this->db->select('user_ordertrackhistory.id')->from('user_ordertrackhistory')->join('users','users.id=user_ordertrackhistory.user_id')->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id')->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left')->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id')->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id')->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE)->group_by('user_orders.unique_order_id')->order_by('user_orders.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.full_name,",",addresses.mobile,",",addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_ordertrackhistory.total_amount as subtotalprice,user_orders.qty,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile,time_slots.from_time as from_time,time_slots.to_time as to_time');
            $this->db->from('user_ordertrackhistory');
            $this->db->join('users','users.id=user_ordertrackhistory.user_id');
            $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
            $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
            $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
            $this->db->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id');
            
            $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
            $this->db->group_by('user_orders.unique_order_id');
            $this->db->order_by('user_orders.id','desc');
            //  $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile');
            //     $this->db->from('user_ordertrackhistory');
            //     $this->db->join('users','users.id=user_ordertrackhistory.user_id');
            //     $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
            //     $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
            //     $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
            //     $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
            //     $this->db->order_by('user_orders.order_taken_on','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();//echo "12<pre>";print_r($result);exit;
      
        $datres=array();
        foreach($result as $row){
            $this->db->select(array("unique_order_id","total_amount"));
            $this->db->where("unique_order_id",$row['unique_order_id']);
             $this->db->from('user_orders');
              $result1 = $this->db->get()->result_array();
                $subtotal=0;
                foreach($result1 as $row3){
                    $subtotal=$subtotal+$row3['total_amount'];
                }
                $sub=array("subtotal"=>$subtotal);
                $payableamt=$subtotal+$row['delivery_charges']-$row['offer_amount']-$row['referral_amount_used'];
                $finalamt=array("final_amt"=>$payableamt);
             $res=array_merge($sub,$row,$finalamt);
             array_push($datres,$res);
             
        }  //echo "12<pre>";print_r($datres);exit;
          //echo $this->db->last_query();exit;
        //  $subtotal=0;
         
    //   $datres=array();
    //     foreach($result as $key=>$row){
    //          $subtotal =$subtotal+($row['price']*$row['qty']);
    //          $sub=array("subtotal"=>$subtotal);
    //          $res=array_merge($sub,$row);
    //          array_push($datres,$res);
             
    //     }//
    // echo "12<pre>";print_r($datres);exit;
        foreach($datres as $key=>$values)
        {
            $datres[$key]['sno'] = $generatesno++;
        }
        return $datres;
    }
  public function all_new_pre_orders($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'user_ordertrackhistory.unique_order_id',
            2 => 'user_ordertrackhistory.user_id',
            3 => 'users.mobile',
            4 => 'user_ordertrackhistory.deliveryboy_status',
            5 => 'user_ordertrackhistory.status'
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
          if($pdata['search_on_1'] != 5)
            {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
          }
        }
         if(isset($pdata['search_text_2'])!="")
        { 
            
            if(($pdata['search_on_1'] == 5)&&($pdata['search_text_2']!=''))
            {
                $s1date=date('Y-m-d', strtotime($pdata['search_text_2']));
                $s2date = date('Y-m-d', strtotime($pdata['search_text_3']));
                  
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') >=", $s1date);
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') <=", $s2date);
            }
        }
        if($getcount)
        {
            return $this->db->select('user_ordertrackhistory.id')->from('user_ordertrackhistory')->join('users','users.id=user_ordertrackhistory.user_id')->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id')->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left')->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id')->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id')->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE)->group_by('user_orders.unique_order_id')->order_by('user_orders.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.full_name,",",addresses.mobile,",",addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_ordertrackhistory.total_amount as subtotalprice,user_orders.qty,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile');
            $this->db->from('user_ordertrackhistory');
            $this->db->join('users','users.id=user_ordertrackhistory.user_id');
            $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
            $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
            $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
             $this->db->where('user_ordertrackhistory.preorder',1);
            $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
            $this->db->group_by('user_orders.unique_order_id');
            $this->db->order_by('user_orders.id','desc');
            //  $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,CONCAT(addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,delivery_boys.name as db_name,delivery_boys.mobile as db_mobile');
            //     $this->db->from('user_ordertrackhistory');
            //     $this->db->join('users','users.id=user_ordertrackhistory.user_id');
            //     $this->db->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id');
            //     $this->db->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id');
            //     $this->db->join('delivery_boys','delivery_boys.id=user_ordertrackhistory.delivery_boy_id','left');
            //     $this->db->where('(((user_ordertrackhistory.status="order_placed" and user_orders.status="order_placed")OR(user_ordertrackhistory.status="accepted" and user_orders.status="accepted")OR(user_ordertrackhistory.status="pickedup" and user_orders.status="pickedup")))',NULL, FALSE);
            //     $this->db->order_by('user_orders.order_taken_on','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();//echo "12<pre>";print_r($result);exit;
      
        $datres=array();
        foreach($result as $row){
            $this->db->select(array("unique_order_id","total_amount"));
            $this->db->where("unique_order_id",$row['unique_order_id']);
             $this->db->from('user_orders');
              $result1 = $this->db->get()->result_array();
                $subtotal=0;
                foreach($result1 as $row3){
                    $subtotal=$subtotal+$row3['total_amount'];
                }
                $sub=array("subtotal"=>$subtotal);
                $payableamt=$subtotal+$row['delivery_charges']-$row['offer_amount']-$row['referral_amount_used'];
                $finalamt=array("final_amt"=>$payableamt);
             $res=array_merge($sub,$row,$finalamt);
             array_push($datres,$res);
             
        }  //echo "12<pre>";print_r($datres);exit;
          //echo $this->db->last_query();exit;
        //  $subtotal=0;
         
    //   $datres=array();
    //     foreach($result as $key=>$row){
    //          $subtotal =$subtotal+($row['price']*$row['qty']);
    //          $sub=array("subtotal"=>$subtotal);
    //          $res=array_merge($sub,$row);
    //          array_push($datres,$res);
             
    //     }//
    // echo "12<pre>";print_r($datres);exit;
        foreach($datres as $key=>$values)
        {
            $datres[$key]['sno'] = $generatesno++;
        }
        return $datres;
    }

    public function get_neworders_status($order_id)
    {


       $this->db->where('id',$order_id);
       $query= $this->db->get('user_ordertrackhistory');
       // echo $this->db->last_query();
       //  exit;
       if($query)
       {
          return $query->row();
       }
       else
       {
          return false;
       }

    }

    public function get_orders_details($order_id)
    {


       $this->db->where('unique_order_id',$order_id);
       $query= $this->db->get('user_orders');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->result_array();
       }
       else
       {
          return false;
       }

    }
    public function get_delivery_boys()
    {

        $this->db->where('delivery_boys.status',1);
       $this->db->where('delivery_boys.delete_status',1);
        $this->db->where('delivery_boys.block_status',1);
       $query= $this->db->get('delivery_boys');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->result();
       }
       else
       {
          return false;
       }

    }
    public function get_time_slots_orders()
    {

      
       $this->db->where('time_slots.delete_status',1);
       $query= $this->db->get('time_slots');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->result();
       }
       else
       {
          return false;
       }

    }

   
    
    /*---------- NewOrders ------------*/
     /*---------- ordered products list ------------*/

    
        public function orders_details($unique_order_id)
    {   
        $data=$this->db->select('user_orders.product_id as product_id,products.product_name as product_name,categories.category_name as category_name,sub_categories.subcategory_name as subcategory_name,user_orders.p_units as units,user_orders.qty as qty,user_orders.p_qty as p_qty,user_orders.total_amount as total_amount')->from('user_orders')->join('products','products.id=user_orders.product_id')->join('categories','categories.id=products.category_id','left')->join('sub_categories','sub_categories.id=products.sub_category_id','left')->join('units_of_measures','units_of_measures.id=products.units','left')->where('user_orders.unique_order_id',$unique_order_id)->order_by('user_orders.id','desc');
        $query= $data->get();
        if($data)
        {
          return $query->result_array();
        }
    }
     public function main_order($order_id)
    {


       $this->db->where('unique_order_id',$order_id);
       $this->db->where('status','delivered');
       $query= $this->db->get('user_ordertrackhistory');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->row_array();
       }
       else
       {
          return false;
       }

    }
    public function main_only_order($order_id)
    {


       $this->db->where('unique_order_id',$order_id);
       //$this->db->where('status','delivered');
       $query= $this->db->get('user_ordertrackhistory');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->row_array();
       }
       else
       {
          return false;
       }

    }
    /*---------- ordered products list ------------*/
    /*----------Completed Orders ------------*/

    
    public function all_completed_orders($pdata, $getcount=null)
    {
        $search_1 = array
        (
            1 => 'user_ordertrackhistory.unique_order_id',
            2 => 'user_ordertrackhistory.user_id',
            3 => 'users.mobile',
            4 => 'user_ordertrackhistory.status'
            
        );        
        if(isset($pdata['search_text_1'])!="")
        {
          if($pdata['search_on_1'] != 4)
            {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
            }
        }
         if(isset($pdata['search_text_2'])!="")
        { 
            
            if(($pdata['search_on_1'] == 4)&&($pdata['search_text_2']!=''))
            {
                $s1date=date('Y-m-d', strtotime($pdata['search_text_2']));
                $s2date = date('Y-m-d', strtotime($pdata['search_text_3']));
                  
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') >=", $s1date);
               $this->db->where("DATE_FORMAT(user_orders.added_on,'%Y-%m-%d') <=", $s2date);
            }
        }
        if($getcount)
        {
            return $this->db->select('user_ordertrackhistory.id')->from('user_ordertrackhistory')->join('users','users.id=user_ordertrackhistory.user_id')->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id')->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id')->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id')->where('((user_ordertrackhistory.status="delivered" and user_orders.status="delivered"))',NULL, FALSE)->group_by('user_orders.unique_order_id')->order_by('user_ordertrackhistory.id','desc')->get()->num_rows();
        }
        else
        {
           $this->db->select('user_ordertrackhistory.*,users.id as user_id,users.mobile as mobile,addresses.address as del_address,CONCAT(addresses.full_name,",",addresses.mobile,",",addresses.house_number,",",addresses.area_street,",",addresses.landmark,",",addresses.state,",",addresses.city,",",addresses.zipcode) as address_selected,DATE_FORMAT(user_orders.added_on,"%d-%m-%Y:%H:%i:%s") as ordered_on,user_orders.status as lstatus,(user_ordertrackhistory.total_amount+user_ordertrackhistory.delivery_charges-user_ordertrackhistory.offer_amount-user_ordertrackhistory.referral_amount_used) as amount_to_be,DATE_FORMAT(user_orders.delivered_on,"%d-%m-%Y:%H:%i:%s") as delivered_on,time_slots.from_time as from_time,time_slots.to_time as to_time')->from('user_ordertrackhistory')->join('users','users.id=user_ordertrackhistory.user_id')->join('user_orders','user_orders.unique_order_id=user_ordertrackhistory.unique_order_id')->join('addresses','addresses.id=user_ordertrackhistory.delivery_address_id')->join('time_slots','time_slots.id=user_ordertrackhistory.time_slot_id',"left")->where('((user_ordertrackhistory.status="delivered" and user_orders.status="delivered"))',NULL, FALSE)->group_by('user_orders.unique_order_id')->order_by('user_ordertrackhistory.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
         $datres=array();
        foreach($result as $row){
            $this->db->select(array("unique_order_id","total_amount"));
            $this->db->where("unique_order_id",$row['unique_order_id']);
             $this->db->from('user_orders');
              $result1 = $this->db->get()->result_array();
                $subtotal=0;
                foreach($result1 as $row3){
                    $subtotal=$subtotal+$row3['total_amount'];
                }
                $sub=array("subtotal"=>$subtotal);
                $payableamt=$subtotal+$row['delivery_charges']-$row['offer_amount']-$row['referral_amount_used'];
                $finalamt=array("final_amt"=>$payableamt);
             $res=array_merge($sub,$row,$finalamt);
             array_push($datres,$res);
             
        }
        foreach($datres as $key=>$values)
        {
            $datres[$key]['sno'] = $generatesno++;
        }
        return $datres;
    }

    public function completed_db_details($db_id)
    {

       
        $this->db->where('delivery_boys.id',$db_id);
       $query= $this->db->get('delivery_boys');
       //  echo $this->db->last_query();
       // exit;
       if($query)
       {
          return $query->row();
       }
       else
       {
          return false;
       }

    }
    
    /*---------- completed Orders ------------*/

     /*--------Admin Password Details------------*/
   public function AdminDetails()
    {
        $this->db->where('id', $this->session->userdata('admin_id'));
        $query = $this->db->get('admin');  
        //echo $this->db->last_query();exit;       
        return $query->row();
    }

    public function UpdatePassword($data)
    {
        $admin_id = $this->session->userdata('admin_id');
        $this->db->where('id', $admin_id);
        $this->db->update('admin', $data); 
        //echo $this->db->last_query();exit;          
        return true;
    }
   
    /*--------Admin Password Details------------*/


    /*-----------push notifications--------*/
    /*-----------push notifications--------*/

/*
public function send_push_notification_notify($message = NULL, $user_ids, $type,$messageType)
    {
       date_default_timezone_set("Asia/Kolkata");
        $reg_ids = array();
        $ios_reg_ids = array();

        $this->db->where_in('delete_status', 1);
        $this->db->where_in('id', $user_ids);
        if($type == "user")
        {
            $this->db->select("id, name, token, ios_token");
            $users = $this->db->get("users");
        }
        elseif($type == "db")
        {
            $this->db->select("id, name, token, ios_token");
            $users = $this->db->get("delivery_boys");
           
        }
        // echo $this->db->last_query();exit;
        $r = array();       
         if($users->num_rows() > 0)
        {
            $result =  $users->result();
            foreach($result as $r)
            {
                if(!empty($r->token) && $r->token != "-" && $r->token != "")
                {
                    array_push($reg_ids, $r->token);
                }
                 if (!empty($r->ios_token) && $r->ios_token != "-" && $r->ios_token != "") {
                    array_push($ios_reg_ids, $r->ios_token);
                }
                $title = "Yummazing";
            }
        }           
        // $message = array('title' => $title, 'message' => $message, 'sent_by' => $sent_by, 'user_id' => $user_id, 'type' => $messageType);
        
          $message = array('title' => $title, 'message' => $message, 'type' => $messageType);//echo "<pre>";print_r($reg_ids);exit;
        if(!empty($reg_ids)){
        $pushStatus = $this->sendAndroidNotificationNotify($reg_ids, $message,$type);
        }
          if(isset($ios_reg_ids) && !empty($ios_reg_ids)){
          //echo "ios<pre>";print_r($ios_reg_ids);exit;
        $pushStatus = $this->sendIosNotification($ios_reg_ids, $message);
         }
        return true;    
    }*/

    public function sendAndroidNotificationNotify($tokens, $message, $sent_to) 
    {
           $url = FIRE_URL;
        $fields = array(
             'registration_ids' => $tokens,
             'data' => $message
            );

        if($sent_to == "user")
        {
            $headers = array(
                'Authorization:key = '.USER_FIRE_KEY,
                'Content-Type: application/json'
                );
        }
        elseif($sent_to == "db")
        {
            $headers = array(
                'Authorization:key = '.DB_FIRE_KEY,
                'Content-Type: application/json'
                );
        }
       
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);  
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);           
        if ($result === FALSE) {
            die('Curl failed: ' . curl_error($ch));
        }
        curl_close($ch);
        //var_dump($result);
        return $result;
    }
    
/*
public function send_push_notification($message = NULL, $user_ids, $persons, $post_type = NULL, $id = NULL, $sent_to)
    {
        date_default_timezone_set("Asia/Kolkata");
        $reg_ids = array();
        $ios_reg_ids = array();

        $this->db->where('delete_status', 1);
        if($persons == "many")
        {
            $this->db->where_in('id', $user_ids);
        }
        else
        {
            $this->db->where('id', $user_ids);
        }
        if($sent_to == "user")
        {
            $this->db->select("id, name, token, ios_token");
            $users = $this->db->get("users");
        }
        elseif($sent_to == "db")
        {
            $this->db->select("id, name, token, ios_token");
            $users = $this->db->get("delivery_boys");
        }
              
       // echo $this->db->last_query();exit;
        $r = array();       
        if($users->num_rows() > 0)
        {
            $result =  $users->result();
            foreach($result as $r)
            {
                
                if(!empty($r->ios_token) && $r->ios_token != "-" && $r->ios_token != "")
                {
                    array_push($ios_reg_ids, $r->ios_token);
                }
                if(!empty($r->token) && $r->token != "-" && $r->token != "")
                {
                    array_push($reg_ids, $r->token);
                }
                $title = "Sami Grocery Notifications";
                //$this->db->insert('notifications', array('user_id' => $r->id, 'title' => $title, 'message' => $message, 'post_id' => $sections_id, 'type' => $post_type, 'created_on' => date('Y-m-d H:i:s')));
                //echo $this->db->last_query();
            }
        }
        //$rowsMsg[] = $message;
        $ios_message = $message;

        //$jsonData = json_encode(array('json' => $rowsMsg));            
        $message = array('title' => $title, 'message' => $message, 'post_type' => $post_type, 'id' => $id);
        //print_r($message);exit;
        //var_dump($reg_ids);
        $pushStatus = $this->sendAndroidNotification($reg_ids, $message, $sent_to);
      // print_r($pushStatus);exit;
      //  $iosPushStatus = $this->sendIosNotification($ios_reg_ids, $ios_message);
        return true;        
    }*/

    public function sendAndroidNotification($tokens, $message, $sent_to) 
    {
        $url = 'https://fcm.googleapis.com/fcm/send';
        $fields = array(
             'registration_ids' => $tokens,
             'data' => $message
            );

        if($sent_to == "user")
        {
            $headers = array(
                'Authorization:key = AAAA0QMh1WM:APA91bGNunMZAkeltA8cpIP35AQGxLnxfUeLXawk6I-NgjwPsKoWWl1ap7H-tYkXgN1IfzMFEgNPIlZ72HJ3PS1wGEYkKuauFZGl-Xo35uXqAAXY6CcIpN0KK7mb9fH2p246emRGMGzK',
                'Content-Type: application/json'
                );
        }
        elseif($sent_to == "db")
        {
            $headers = array(
                'Authorization:key = AAAA1ZxsUi4:APA91bHmjLJkPqgkwRtTbJ5EZTD3sq_RxKe1irRJ0UlDJkWn8zo_uNbvBIGEsQVTSvoXr6hfzv9m694JJJTiiyri9lTNxFmTLAEKyTn7u2cMTq_B1Mv8Y7s3qt_W3ov-TSok8LsJmZFa',
                'Content-Type: application/json'
                );
        }
       
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);  
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);           
        if ($result === FALSE) {
            die('Curl failed: ' . curl_error($ch));
        }
        curl_close($ch);
        //var_dump($result);
        return $result;
    }

     public function sendIosNotification($tokens, $message)
    {//USER_FIRE_KEY FIRE_URL
        $fcmMsg = array(
             'body' => $message['message'],
            'title'=>$message['title'],
            'sound' => "default",
            'color' => "#203E78" 
        );  

        // 'to' => $singleID ;  // expecting a single ID
        // 'registration_ids' => $registrationIDs ;  // expects an array of ids
        // 'priority' => 'high' ; // options are normal and high, if not set, defaults to high.
        $fcmFields = array(
            'registration_ids' => $tokens,
            'priority' => 'high',
            'notification' => $fcmMsg
        );

        $headers = array(
            'Authorization: key=' . USER_FIRE_KEY,
            'Content-Type: application/json'
        );
         
        $ch = curl_init();
        curl_setopt( $ch,CURLOPT_URL, FIRE_URL );
        curl_setopt( $ch,CURLOPT_POST, true );
        curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
        curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch,CURLOPT_POSTFIELDS, json_encode( $fcmFields ) );
        $result = curl_exec($ch );
        curl_close( $ch );
        //echo $result . "\n\n";//exit;
        return true;
    }
/*--------------push notifications--------*/

/*----------------------New Code----------------*/
function get_inventory_items($id)
{
    $sql="select group_concat(item_name) as items from inventory where id in(".$id.")";
 return $this->db->query($sql)->result();   
}


/*-----------edited by sagar --------------*/
 /*city management*/
     public function all_luckydraws($pdata, $getcount=null)
    {
       // print_r($pdata);
       // echo $getcount;exit;
        
        $search_1 = array
        (
            1 => 'lucky_draw'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            return $this->db->select('lucky_draw_events.id')->from('lucky_draw_events')->order_by('lucky_draw_events.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('lucky_draw_events.*,DATE_FORMAT(lucky_draw_events.created_on,"%d-%m-%Y %l-%i %p") as created_on,DATE_FORMAT(lucky_draw_events.lucky_draw_time,"%h:%i:%s:%p") as lucky_draw_time,
            DATE_FORMAT(lucky_draw_events.validity_date,"%d-%m-%Y") as validity_date, DATE_FORMAT(lucky_draw_events.lucky_draw_date,"%d-%m-%Y") as lucky_draw_date,')->from('lucky_draw_events')->order_by('lucky_draw_events.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0; 
        }
       // echo $sql;exit;
       //echo $this->db->last_query();
        $result = $this->db->get()->result_array();
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
    }
    public function lucky_draw_details($event_name)
    {   
        //$this->db->where('delete_status',1);
        $this->db->like("replace(event_name, ' ', '')", "$event_name",'none');
       $query= $this->db->get('lucky_draw_events');

       if($query->num_rows()>0)
       {
          return true ;
       }
       

    }
    
     public function delete_lucky_draw_events($id)
    {

      

        $this->db->where('id',$id);
       $query= $this->db->update('lucky_draw_events',array('delete_status'=>0));



      
       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }
    // public function get_cities($categoryid)
    // {   
    //     $this->db->where('delete_status',1);
    //     $this->db->where('id',$categoryid);
    //   $query= $this->db->get('cities');

    //   if($query)
    //   {
    //       return $query->row();
    //   }
       

    // }
    /*city management*/
    
    /*get lucky draw banners*/
    public function all_luckydraw_banners($pdata, $getcount=null)
    {
       // $getcount = null;
        $search_1 = array
        (
            1 => 'description'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            //echo $getcount;exit;
            return $this->db->select('lucky_draw_banners.id')->from('lucky_draw_banners')->where('lucky_draw_banners.delete_status',1)->order_by('lucky_draw_banners.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('lucky_draw_banners.*,DATE_FORMAT(lucky_draw_banners.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(lucky_draw_banners.updated_on,"%d-%m-%Y:%H:%i:%s") as updated_on')->from('lucky_draw_banners')->where('lucky_draw_banners.delete_status',1)->order_by('lucky_draw_banners.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
        
        //             $query = $this->db->get();
        
        // $data = array();
        // if($query !== FALSE && $query->num_rows() > 0){
        //     $data = $query->result_array();
        //     foreach($data as $key=>$values)
        //  {
        //      $datat[$key]['sno'] = $generatesno++;
        // }
        
        // }
        
        // return $data;


    }

    public function delete_luckydraw_banners($pbid)
    {

      
        $this->db->where('id',$pbid);
       $query= $this->db->delete('lucky_draw_banners');

       
       if($query)
       {
          return true;
       }
       else
       {
          return false;
       }

    }


    public function get_luckydraw_banners($banner_id)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$banner_id);
       $query= $this->db->get('lucky_draw_banners');

       if($query)
       {
          return $query->row();
       }
       

    }
    
    public function get_coupons_data($offset, $limit)
    {
        $this->db->select('draw_coupons.*,addresses.*,lucky_draw_events.*, lucky_draw_events.id as luckydraw_id,draw_coupons.id as draw_coupon_id');
        $this->db->from('draw_coupons');
        $this->db->join('addresses','addresses.user_id = draw_coupons.user_id','left');
        $this->db->join('lucky_draw_events','lucky_draw_events.id = draw_coupons.lucky_draw_id','left');
       // $this->db->join('users','users.user_id = draw_coupons.user_id','left');
        $this->db->where('lucky_draw_events.delete_status', '1');
        $this->db->order_by('draw_coupons.id','desc');
        $this->db->limit($limit, $offset);
        $query = $this->db->get();
       // echo $query;exit;
        return  $query->result();
        
    }
    
    public function get_single_coupons_data($id)
    {
         $this->db->select('draw_coupons.*,addresses.*,lucky_draw_events.*, lucky_draw_events.id as luckydraw_id,draw_coupons.id as draw_coupon_id');
        $this->db->from('draw_coupons');
        $this->db->join('addresses','addresses.user_id = draw_coupons.user_id','left');
        $this->db->join('lucky_draw_events','lucky_draw_events.id = draw_coupons.lucky_draw_id','left');
       // $this->db->join('users','users.user_id = draw_coupons.user_id','left');
        $this->db->where('lucky_draw_events.delete_status', '1');
        $this->db->where('draw_coupons.lucky_draw_id', $id);
        $this->db->order_by('draw_coupons.id','desc');
        $query = $this->db->get();
       // echo $query;exit;
        return  $query->result();
    }
    
    /*get lucky draw banners*/
    
    /*get all users details*/
    public function get_users_data()
    {
    //     $this->db->select('users.*,users.mobile as primary_number,addresses.mobile as alternative_no,addresses.zipcode,addresses.area_street,addresses.property_name,addresses.block_number,
    //          DATE_FORMAT(users.created_on,"
             
             
    //          %d-%m-%Y:%H:%i:%s") as created_on');
    //     $this->db->from('users');
    //     $this->db->join('addresses','addresses.user_id = users.id','left');
    //   // $this->db->join('lucky_draw_events','lucky_draw_events.id = draw_coupons.lucky_draw_id','left');
    //   // $this->db->join('users','users.user_id = draw_coupons.user_id','left');
    //     $this->db->where('users.delete_status', '1');
    //   //  $this->db->where('addresses.default_address', '1');
    //     $this->db->order_by('users.id','desc');
        
        
        
        $this->db->select('users.*,(SELECT addresses.mobile FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 limit 0,1) alternative_number,
              (SELECT addresses.zipcode FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 limit 0,1) zipcode,
              (SELECT addresses.area_street FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 limit 0,1) area_street,
              (SELECT addresses.property_name FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 limit 0,1) property_name,
              (SELECT addresses.block_number FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1 limit 0,1) block_number,
          
             (SELECT COUNT(draw_coupons.user_id) FROM draw_coupons WHERE draw_coupons.user_id = users.id) ld_coupons_used,
             (SELECT COUNT(users.id) FROM users WHERE users.referred_by = users.referral_code) referral_count,
             (SELECT COUNT(addresses.id) FROM addresses WHERE addresses.user_id = users.id AND addresses.delete_status = 1) addresses_count,
             users.mobile as primary_number, DATE_FORMAT(users.created_on,"%d-%m-%Y:%H:%i:%s") as created_on');
             $this->db->from('users');
            // $this->db->join('addresses','addresses.user_id = users.id','left');(SELECT CONCAT(addresses.mobile,"-",addresses.zipcode,"-",addresses.area_street,"-",addresses.property_name,"-",addresses.block_number)  FROM addresses WHERE addresses.user_id = users.id AND addresses.default_address = 1) A ,
             //$this->db->join('draw_coupons','draw_coupons.user_id = users.id','left');
             $this->db->where('users.delete_status',1);
             //$this->db->where('addresses.default_address',1);
             $this->db->order_by('users.id','desc');
        $query = $this->db->get(); 
  //  echo   $this->db->last_query();exit;
        return  $query->result();
    }
    /*get all users details*/
    
    /*reports fetching module*/
    public function all_reports($pdata, $getcount=null)
    {
       // $getcount = null;
        $search_1 = array
        (
            1 => 'description'
        );        
        if(isset($pdata['search_text_1'])!="")
        {
            $this->db->like($search_1[$pdata['search_on_1']], $pdata['search_text_1'], $pdata['search_at_1'] ); 
        }
        if($getcount)
        {
            //echo $getcount;exit;
            return $this->db->select('reports.id')->from('reports')->where('reports.delete_status',1)->order_by('reports.id','desc')->get()->num_rows();
        }
        else
        {
            $this->db->select('reports.*,DATE_FORMAT(reports.created_on,"%d-%m-%Y:%H:%i:%s") as created_on,DATE_FORMAT(reports.updated_on,"%d-%m-%Y:%H:%i:%s") as updated_on')->from('reports')->where('reports.delete_status',1)->order_by('reports.id','desc');
        }
        if(isset($pdata['length']))
        {
            $perpage = $pdata['length'];
            $limit = $pdata['start'];
            $generatesno=$limit+1;
            $this->db->limit($perpage,$limit);
        }
        else
        {
            $generatesno = 0;
        }
        $result = $this->db->get()->result_array();
        
        //echo $this->db->last_query();
        foreach($result as $key=>$values)
        {
            $result[$key]['sno'] = $generatesno++;
        }
        return $result;
        
        //             $query = $this->db->get();
        
        // $data = array();
        // if($query !== FALSE && $query->num_rows() > 0){
        //     $data = $query->result_array();
        //     foreach($data as $key=>$values)
        //  {
        //      $datat[$key]['sno'] = $generatesno++;
        // }
        
        // }
        
        // return $data;


    }

    public function delete_reports($pbid)
    {

      
        $this->db->where('id',$pbid);
       $query= $this->db->delete('reports');

       
       if($query)
       {
          return true;
       }
       else  
       {
          return false;
       }

    }


    public function get_reports($id)
    {   
        $this->db->where('delete_status',1);
        $this->db->where('id',$id);
       $query= $this->db->get('reports');

       if($query)
       {
          return $query->row();
       }  
       

    }
    /*reports fetching module*/
    
    /*----------------wallet offers-----------------------------------------------------------*/
    
    public function fetch_wallet_offers($perpage,$limit)
    {
        $this->db->select('*');
        $this->db->from('wallet_offers');
        $this->db->where('delete_status',1);
        $this->db->limit($perpage,$limit);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
        
    }
    
        public function fetch_all_zones($zone_name,$limit, $start)
    {
        $this->db->select()->from("zones");
        (!empty($zone_name))?$this->db->where("zone_name",$zone_name):"";
        //(!empty($city))?$this->db->where("city",$city):"";
        //(!empty($area))?$this->db->like("area",$area,"both"):"";
       // (!empty($status))?$this->db->where("db_status",$status):"";
      // $this->db->where('delete_status ','1');
       $this->db->limit($limit, $start);
        $this->db->order_by("id","desc");
    		$qry=$this->db->get();
    		return $qry->result();
        
    }
    
    public function get_copons_details($id,$limit, $start)
    {
        $this->db->select()->from("draw_coupons");
        (!empty($id))?$this->db->where("lucky_draw_id",base64_decode($id)):"";
        //(!empty($city))?$this->db->where("city",$city):"";
        //(!empty($area))?$this->db->like("area",$area,"both"):"";
       // (!empty($status))?$this->db->where("db_status",$status):"";
      // $this->db->where('delete_status ','1');
       $this->db->limit($limit, $start);
        $this->db->order_by("id","desc");
    		$qry=$this->db->get();
    		return $qry->result();
    }
    
    public function fetch_sub_cancel_reasons($perpage,$limit)
    {
        $this->db->select('*');
        $this->db->from('sub_cancel_reasons');
        $this->db->where('delete_status',1);
        $this->db->limit($perpage,$limit);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
        
    }
    
     public function fetch_db_cancel_reasons($perpage,$limit)
    {
        $this->db->select('*');
        $this->db->from('db_cancel_reasons');
        $this->db->where('delete_status',1);
        $this->db->limit($perpage,$limit);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
        
    }
    
    public function get_area_for_assign_orders()
    {
        $this->db->distinct();
        $this->db->select('area_street as area,property_name as property_name');
        $this->db->from('addresses');
        $this->db->where('delete_status',1);
        //$this->db->limit($perpage,$limit);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    
     public function get_all_orders_for_assign()
    {
        $startdate = date('Y-m-d 00:00:00');
            $enddate = date('Y-m-d 23:59:59');
        $this->db->select('user_orders.*,user_orders.id,user_orders.unique_order_id,user_orders.added_on,user_orders.db_status, dark_stores.store_name,
                           addresses.area_street,addresses.property_name,addresses.block_number,addresses.first_name');
        $this->db->from('user_orders');
        $this->db->join('addresses','addresses.id = user_orders.address_id','left');
        $this->db->join('dark_stores','dark_stores.id = user_orders.dark_store','left');
        $this->db->where('user_orders.added_on >=',$startdate);
        $this->db->where('user_orders.added_on <=',$enddate);
        $this->db->or_where('user_orders.db_status ','received');
      //  $this->db->where('(user_orders.added_on >= '.$startdate.' AND user_orders.added_on <= '.$enddate.') OR (db_status = "received")');
        //$this->db->limit($perpage,$limit);
        $this->db->order_by('user_orders.id','desc');
        $query = $this->db->get();
      //  echo $this->db->last_query();exit;
        return $query->result();
    }
    
    public function get_all_sub_orders_for_assign_db()
    {
        $this->db->select('subscription_orders.*,subscription_orders.id,subscription_orders.sub_order_id as unique_order_id,subscription_orders.order_date as added_on,subscription_orders.status as db_status, 
        subscription_orders.sub_id,dark_stores.store_name,addresses.area_street,addresses.property_name,addresses.block_number,addresses.first_name');
        $this->db->from('subscription_orders');
        $this->db->join('addresses','addresses.id = subscription_orders.address_id','left');
        $this->db->join('dark_stores','dark_stores.id = subscription_orders.dark_store','left');
        $this->db->where('subscription_orders.order_date',date('Y-m-d'));
        $this->db->or_where('subscription_orders.status','order_placed');
       // $this->db->where('subscription_orders.order_date <=',$enddate);
        //$this->db->limit($perpage,$limit);
        $this->db->order_by('subscription_orders.id','desc');
        $query = $this->db->get();
       // echo $this->db->last_query();exit;
        return $query->result();
    }
    
    public function get_all_orders_for_assign_search($from_date,$to_date,$zone,$order_type,$order_status,$area,$property_name)
    {
        // if($order_status == "order_placed"){
        // 	         $order_status = "received";
        // 	     }
        
         $this->db->select('user_orders.*,user_orders.id,user_orders.unique_order_id,user_orders.added_on,user_orders.db_status, dark_stores.store_name,
                           addresses.area_street,addresses.property_name,addresses.block_number,addresses.first_name');
        $this->db->from('user_orders');
        $this->db->join('addresses','addresses.id = user_orders.address_id','left');
        $this->db->join('dark_stores','dark_stores.id = user_orders.dark_store','left');
        if(!empty($from_date)){
         $this->db->where('user_orders.added_on >=',$from_date);
        }
        if(!empty($to_date)){
        $this->db->where('user_orders.added_on <=',$to_date);
        }
        if(!empty($zone)){
            $this->db->where('user_orders.dark_store',$zone);
        }
        
        if(!empty($area)){
           $this->db->where('addresses.area_street',$area);
        }
        if(!empty($property_name)){
            $this->db->where('addresses.property_name',$property_name);
        }
        if(!empty($order_status)){
            $this->db->where('user_orders.db_status',$order_status);
        }
            $this->db->or_where('user_orders.db_status','received');
        
        
        $this->db->order_by('user_orders.id','desc');
        $query = $this->db->get();
     //   echo $this->db->last_query();exit;
        return $query->result();
    }
    
    public function get_all_sub_orders_for_assign_db_search($from_date,$to_date,$zone,$order_type,$order_status,$area,$property_name)
    {
        if($order_status == "received"){
        	         $order_status = "order_placed";
        	     }
        $this->db->select('subscription_orders.*,subscription_orders.id,subscription_orders.sub_order_id as unique_order_id,subscription_orders.order_date as added_on,subscription_orders.status as db_status, 
        subscription_orders.sub_id,dark_stores.store_name,addresses.area_street,addresses.property_name,addresses.block_number,addresses.first_name');
        $this->db->from('subscription_orders');
        $this->db->join('addresses','addresses.id = subscription_orders.address_id','left');
        $this->db->join('dark_stores','dark_stores.id = subscription_orders.dark_store','left');
         if(!empty($from_date)){
        $this->db->where('subscription_orders.order_date >=',$from_date);
         }
           if(!empty($to_date)){
        $this->db->where('subscription_orders.order_date <=',$to_date);
           }
        if(!empty($zone)){
            $this->db->where('subscription_orders.dark_store',$zone);
        }
        if(!empty($zone)){
          //  $this->db->where('subscription_orders.zone',$zone);
        }
        
        if(!empty($area)){
           $this->db->where('addresses.area_street',$area);
        }
        if(!empty($property_name)){
            $this->db->where('addresses.property_name',$property_name);
        }
        if(!empty($order_status)){
            $this->db->where('subscription_orders.status',$order_status);
        }
            $this->db->or_where('subscription_orders.status','order_placed');
        
        
        //$this->db->limit($perpage,$limit);
        $this->db->order_by('subscription_orders.id','desc');
        $query = $this->db->get();
     //   echo $this->db->last_query();exit;
        return $query->result();
    }
    
    public function get_cart_products_volume($unique_order_id)
    {
        $this->db->select('sum(units_of_measures.volume*cart.qty) as order_volume');
        $this->db->from('cart');
        $this->db->join('products','products.id = cart.product_id','left');
        $this->db->join('units_of_measures','units_of_measures.id = products.units','left');
        $this->db->where('cart.order_id',$unique_order_id);
        $query = $this->db->get();
       // echo $this->db->last_query();exit;
        return $query->result();
    }
    
    public function get_subcart_products_volume($sub_id)
    {
        $this->db->select('sum(units_of_measures.volume*subscription_cart.quantity) as order_volume');
        $this->db->from('subscription_cart');
        $this->db->join('products','products.id = subscription_cart.product_id','left');
        $this->db->join('units_of_measures','units_of_measures.id = products.units','left');
        $this->db->where('subscription_cart.order_id',$sub_id);
        $query = $this->db->get();
       // echo $this->db->last_query();exit;
        return $query->result();
    }
    public function get_all_sub_orders_for_assign()
    {
        $this->db->select('subscription_orders.*');
        $this->db->from('subscription_orders');
        $this->db->limit(10,0);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    public function get_all_man_orders_for_assign()
    {
        $this->db->select('manual_cart.*');
        $this->db->from('manual_cart');
        $this->db->limit(10,0);
        $this->db->order_by('id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    
    public function get_order_products_volumes($ord)
    {
        $this->db->select('cart.qty,products.id,products.name,units_of_measures.volume');
        $this->db->from('cart');
        $this->db->join('products','products.id = cart.product_id','left');
        $this->db->join('units_of_measures','units_of_measures.id = products.units','left');
        $this->db->where('cart.order_id',$ord);
        $query = $this->db->get();
       // echo $this->db->last_query();exit;
        return $query->result();
    } 
    
    public function get_sub_order_products_volumes($ord)
    {
        $this->db->select('subscription_cart.quantity as qty,products.id,products.name,units_of_measures.volume');
        $this->db->from('subscription_cart');
        $this->db->join('products','products.id = subscription_cart.product_id','left');
        $this->db->join('units_of_measures','units_of_measures.id = products.units','left');
        $this->db->where('subscription_cart.order_id',$ord);
        $query = $this->db->get();
       //echo $this->db->last_query();exit;
        return $query->result();
    } 
    
    /*new zones module*/
public function add_new_zones_module($name){
    $this->db->insert('zones',$name);
    $id = $this->db->insert_id();
    return $id;
}
public function insert_new_coordinates($ro){
    $this->db->insert('zone_areas',$ro);
    $this->db->insert_id();
}
/*new zones module*/

function get_all_sales_dbs()
    {
        $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered'
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC
        
        
        ";
        $query = $this->db->query($sql);
        return $query->result();
    }
    
function get_all_sales_dbs_search($boy,$search_date)
    {
        if($search_date == "uptodate" || $search_date == ""){
            if(empty($boy)){
                 $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered'
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }else{
                 $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered' AND user_orders.db_id = $boy
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }
           
                 
        }else if($search_date == "month"){
            if(empty($boy)){
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id 
                 WHERE user_orders.db_status = 'delivered' AND 
                 MONTH(user_orders.delivered_on) = ".date('m')." AND YEAR(user_orders.delivered_on) = ".date('Y')."
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }else{
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id 
                 WHERE user_orders.db_status = 'delivered' AND user_orders.db_id = $boy AND 
                 MONTH(user_orders.delivered_on) = ".date('m')." AND YEAR(user_orders.delivered_on) = ".date('Y')."
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }
            
        }else if($search_date == "week"){
            if(empty($boy)){
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered' AND week(user_orders.delivered_on) = week(now())
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }else{
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered' AND user_orders.db_id = $boy AND week(user_orders.delivered_on) = week(now())
                 GROUP BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d'),user_orders.db_id
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }
            
            
        }else if($search_date == "today"){
            $startdate = date('Y-m-d 00:00:00');
            $enddate = date('Y-m-d 23:59:59');
            if(empty($boy)){
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered' 
                 AND user_orders.delivered_on >= '".$startdate."' AND user_orders.delivered_on <= '".$enddate."'
                
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }else{
                $sql = " SELECT delivery_boys.name,delivery_boys.mobile,user_orders.*
                 FROM user_orders 
                 LEFT JOIN delivery_boys ON delivery_boys.id = user_orders.db_id
                 WHERE user_orders.db_status = 'delivered' AND user_orders.db_id = $boy
                 AND user_orders.delivered_on >= '".$startdate."' AND user_orders.delivered_on <= '".$enddate."'
                
                 ORDER BY DATE_FORMAT(user_orders.delivered_on,'%y-%m-%d') DESC";
            }
            
            
            
        }
        //echo $this->db->last_query();exit;
        $query = $this->db->query($sql);
       // echo $this->db->last_query();exit;
        return $query->result();
    }
    
    
    /*-------------------------db----------------------------------*/
    function get_db_inventory_data()
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
        $this->db->where('db_inventory.status','request');
        $this->db->or_where('db_inventory.status','approved');
        $this->db->or_where('db_inventory.status','instock');
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    function get_db_inventory_data_ajax($delivery_boy,$status)
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
        if(!empty($delivery_boy)){
             $this->db->where('db_inventory.db_id',$delivery_boy);
        } if(!empty($status)){
              $this->db->where('db_inventory.status',$status);
        }else{
            $this->db->group_start();
            $this->db->where('db_inventory.status','request');
        $this->db->or_where('db_inventory.status','approved');
        $this->db->or_where('db_inventory.status','instock');
        $this->db->group_end();
        }
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    
    function get_db_inventory_data_of_one($db_id)
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
        $this->db->where('db_inventory.db_id',$db_id);
        $this->db->where('db_inventory.status','request');
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    
    function get_db_inventory_data_return()
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
        $this->db->where('db_inventory.status','return_request');
        $this->db->or_where('db_inventory.status','completed');
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    function get_db_inventory_data_return_ajax($delivery_boy,$status)
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
       
        if(!empty($delivery_boy)){
             $this->db->where('db_inventory.db_id',$delivery_boy);
        } if(!empty($status)){
              $this->db->where('db_inventory.status',$status);
        }else{
            $this->db->group_start();
             $this->db->where('db_inventory.status','return_request');
        $this->db->or_where('db_inventory.status','completed');
        $this->db->group_end();
        }
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
       // echo $this->db->last_query();exit;
        return $query->result();
    }
    
    function get_db_inventory_data_of_return($db_id)
    {
        $this->db->select('db_inventory.*,products.name as product_name,products.image,delivery_boys.name as db_name,delivery_boys.mobile');
        $this->db->from('db_inventory');
        $this->db->join('products','products.id = db_inventory.product_id','left');
        $this->db->join('delivery_boys','delivery_boys.id = db_inventory.db_id','left');
        $this->db->where('db_inventory.db_id',$db_id);
        $this->db->where('db_inventory.status','return_request');
        $this->db->order_by('db_inventory.id','desc');
        $query = $this->db->get();
        return $query->result();
    }
    
/*edited by sagar */
   
}
?>