
<style>
        /* Add your own styles for the overlay and modal */
        #overlay {
            display: none;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.5);
            justify-content: center;
            align-items: center;
            z-index: 1;
        }

        #modal {
            display: none;
            background-color: white;
            padding: 20px;
            border-radius: 10px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.5);
        }
    </style>
<script>
        document.addEventListener('DOMContentLoaded', function () {
            var overlay = document.getElementById('overlay');
            var modal = document.getElementById('modal');

            // Function to show the overlay and modal
            function showOverlay() {
                overlay.style.display = 'flex';
                modal.style.display = 'block';
            }

            // Function to hide the overlay and modal
            function hideOverlay() {
                overlay.style.display = 'none';
                modal.style.display = 'none';
            } 

            // Simulate form submission
            document.getElementById('validation').addEventListener('submit', function (event) {
                event.preventDefault();

                // Show overlay and modal
                showOverlay();

                // Simulate a delay (you can replace this with your actual form submission logic)
                setTimeout(function () {
                    // Hide overlay and modal after the delay
                    hideOverlay();

                    // Redirect to the success page
                   // window.location.href = 'success.html';
                }, 10000); // Adjust the time as needed
            });
        });
    </script>

<!-- START BREADCRUMB -->
<ul class="breadcrumb">
  <li><a href="#">Home</a></li>
  <li><a href="#">States</a></li>
  <li class="active">Add Lucky Draw Events</li>
</ul>
<!-- END BREADCRUMB -->

<!-- PAGE CONTENT WRAPPER -->
<div class="page-content-wrap">
  <div class="row">
    <div class="col-md-12">
      <?php 
      $attributes = array('class' => 'form-horizontal', 'id' => 'validation');
      echo form_open_multipart('admin/register/update_event_coupons', $attributes); 
      ?>
        <div class="panel panel-default">
          <div class="panel-heading" style='display:flex;gap:1rem;'>
              <a href='<?=base_url();?>admin/register/luckydraw_events'><img src='https://eeggshop.com/es_admin/image/previous.png' style='width:28px'></a>
            <h2 class="panel-title">Add Lucky Draw Event</h2>            
          </div>
          <?php if($this->session->flashdata('success') != "") : ?>                
            <div class="alert alert-success" role="alert">
              <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
              <?=$this->session->flashdata('success');?>
            </div>


          <?php endif; ?>
          <?php if($this->session->flashdata('success_error') != "") : ?>                
            <div class="alert alert-danger" role="alert">
              <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
              <?=$this->session->flashdata('success_error');?>
            </div>

            
          <?php endif; ?>

          <div class="panel-body">            

            <div class="input_fields_wrap gray points-cont">
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Event Name</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="text" class="form-control" name="event_name" id="event_name" placeholder="Add Event Name" />
                </div>
              </div>
              
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Coupons Required</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="number" class="form-control" name="no_of_coupons" id="no_of_coupons" placeholder="Add Coupons required" />
                </div>
              </div>
              
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Validity Date</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="date" class="form-control" name="validity_date" id="validity_date" placeholder="Select validity Date"/>
                </div>
              </div>
              
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Lucky Draw Date</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="date" class="form-control" name="lucky_draw_date" id="lucky_draw_date" placeholder="Select Lucky Draw Date"/>
                </div>
              </div>
              
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Lucky Draw Time</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="time" class="form-control" name="lucky_draw_time" id="lucky_draw_time" placeholder="Select Lucky Draw Time"/>
                </div>
              </div>
              
              
              
              
             
            <a href="<?=base_url();?>admin/register/luckydraw_events" class="btn btn-primary pull-right" style="margin-left:10px;">Cancel</a>    
            <button type="submit" class="btn btn-primary pull-right" id="btnSubmit">Add</button>
         
        </div>
      </form>
      
      <!-- Overlay and modal for displaying loading message -->
    <div id="overlay">
        <div id="modal">
            <p>Coupons are generating. Please wait...</p>
        </div>
    </div>

    </div>
  </div>
</div>
<!-- END PAGE CONTENT WRAPPER -->
<script src="<?php echo base_url(); ?>assets/js/jquery.validate.js"></script>
<script src="<?php echo base_url(); ?>assets/js/jquery-validate-additional-methods.js"></script>
<script>
  $(document).ready(function() { //alert();
      $("#validation").validate({
          rules: {
            // simple rule, converted to {required:true}            
                category: {
                required : true,
            }
            ,
             icon: {
                 required:true,
                extension: "pdf|jpg|png|gif|jpeg"
            }
          },


           messages: {
        
        icon: {
            extension: "Allowed Extensions:pdf|jpg|png|gif|jpeg",
            
        },
        
    },
          submitHandler: function(form) {
              $("#btnSubmit").prop('disabled', true);
              form.submit();
          }
        });
  });

</script>
