<!-- views/map_view.php -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>Map View</title>
    <!-- <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyB33gBx5ZkfumpQ_Qu9zcbF46PEJhudTeI&libraries=drawing"></script> -->    

    <script async defer src="https://maps.googleapis.com/maps/api/js?key=AIzaSyB33gBx5ZkfumpQ_Qu9zcbF46PEJhudTeI&libraries=drawing&callback=initMap"></script>

    <script src="https://maps.googleapis.com/maps/api/js?key=YOUR_GOOGLE_MAPS_API_KEY&libraries=geometry"></script>

    
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

    <script>
          

</script>

<script>

var map;
    var markers = [];
    function initMap() {
        //alert('hi');
        
        map = new google.maps.Map(document.getElementById('map'), {
            center: {lat: 17.399036761668327, lng: 78.47810189422704},
            zoom: 8
        });   
        
        // Add drawing manager for region selection
        var drawingManager = new google.maps.drawing.DrawingManager({
            //alert('hello');
            drawingControl: true,
            drawingControlOptions: {
                position: google.maps.ControlPosition.TOP_CENTER,
                drawingModes: ['polygon']
            },
            polygonOptions: {
                editable: true,
                draggable: true
            }
        });        

        drawingManager.setMap(map);
            google.maps.event.addListener(drawingManager, 'overlaycomplete', function(event) {
            if (event.type === 'polygon') {
                //alert('hi');
                var path = event.overlay.getPath().getArray();
                var coordinates = [];
                for (var i = 0; i < path.length; i++) {
                    coordinates.push({
                        lat: path[i].lat(),
                        lng: path[i].lng()
                    });
                }
                //alert(coordinates);
                console.log("Selected region coordinates:", coordinates);

                $(document).on("click","#saveCoordinates",function() {
                    /* if(coordinates===''){
                        alert('please select zones');
                    } */
                var name = $('#zone_name').val();
                //alert(name);
                if(name == ''){
                    alert('Zone name cannot be empty');
                }else{
                // Send coordinates to the backend using AJAX
                    $.ajax({
                        type: 'POST',
                        url: '<?php echo base_url('admin/register/saveCoordinates');?>', // Update this URL with your actual controller and method
                        data: {coordinates: JSON.stringify(coordinates),name:name},
                        success: function(response) {
                            if(response==1){
                                alert('Zone name added already');
                            }else{
                                alert('Zone inserted successfully');
                                location.reload();
                            }
                        },
                        error: function(error) {
                            console.error(error);
                        }
                    });
                }
            });

            }
        });
        
        

        //pincode search
        $(document).on("click","#searchpincode",function() {
            //alert('hi');
            var pincode = $('#pincodeInput').val();

            // Fetch location information from server using AJAX
            $.ajax({
                url: '<?php echo base_url("admin/register/searchLocationByPincode/") ?>' + pincode,
                type: 'GET',
                dataType: 'json',
                success: function (data) {
                    // Use data to display information on the map
                    if (data.results && data.results.length > 0) {
                        var location = data.results[0].geometry.location;
                        //initializeMap(location);
                        var map = new google.maps.Map(document.getElementById('map'), {
                            center: location,
                            zoom: 8
                        });

                        // Create a marker for the location
                        var marker = new google.maps.Marker({
                            position: location,
                            map: map,
                            title: 'Searched Location'
                        });

        // Add drawing manager for region selection
        var drawingManager = new google.maps.drawing.DrawingManager({
            //alert('hello');
            drawingControl: true,
            drawingControlOptions: {
                position: google.maps.ControlPosition.TOP_CENTER,
                drawingModes: ['polygon']
            },
            polygonOptions: {
                editable: true,
                draggable: true
            }
        });        

        drawingManager.setMap(map);
            google.maps.event.addListener(drawingManager, 'overlaycomplete', function(event) {
            if (event.type === 'polygon') {
                //alert('hi');
                var path = event.overlay.getPath().getArray();
                var coordinates = [];
                for (var i = 0; i < path.length; i++) {
                    coordinates.push({
                        lat: path[i].lat(),
                        lng: path[i].lng()
                    });
                }
                //alert(coordinates);
                console.log("Selected region coordinates:", coordinates);

                $(document).on("click","#saveCoordinates",function() {
                    /* if(coordinates===''){
                        alert('please select zones');
                    } */
                var name = $('#zone_name').val();
                //alert(name);
                if(name == ''){
                    alert('Zone name cannot be empty');
                }else{
                // Send coordinates to the backend using AJAX
                    $.ajax({
                        type: 'POST',
                        url: '<?php echo base_url('admin/register/saveCoordinates');?>', // Update this URL with your actual controller and method
                        data: {coordinates: JSON.stringify(coordinates),name:name},
                        success: function(response) {
                            if(response==1){
                                alert('Zone name added already');
                            }else{
                                alert('Zone inserted successfully');
                                location.reload();
                            }
                        },
                        error: function(error) {
                            console.error(error);
                        }
                    });
                }
            });

            }
        });
                        
                    } else {
                        alert('No location found for the provided PIN code.');
                    }
                },
                error: function () {
                    alert('Error fetching location information.');
                }
            });                    

        });
        //pincode search

                               
    } 
    
    </script>

</head>
<body>
    <div class="panel panel-default">
          <div class="panel-heading" style='display:flex;gap:1rem;'>
              <a href='<?=base_url();?>admin/register/new_zones'><img src='https://eeggshop.com/es_admin/image/previous.png' style='width:28px'></a>
            <h2 class="panel-title">Add New Zone</h2>            
          </div>
          
          
    <br><br><br><br><br>
    
            <div class="form-group">
               <label for="state" class="col-md-3 col-xs-12 control-label">Zone Name</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                 <input type="text" class="form-control" name="zone_name" id="zone_name" value="" />
                </div>
              </div>
              <br><br>
              
<!--<div class="form-group">-->
<!--<label for="state" class="col-md-3 col-xs-12 control-label">Zone Name</label>-->
<!--<div class="col-md-6 col-xs-12">                -->
<!--    <span class="input-group-addon"><i class="fa fa-pencil"></i></span>-->
<!--    <input type="text" class="form-control" name="zone_name" id="zone_name" value="" />-->
<!--</div>-->
<!--</div>-->
            <div class="form-group">
               <label for="state" class="col-md-3 col-xs-12 control-label">Zone Name</label>
            <div class="col-md-6 col-xs-12">                
                <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                <input type="text" id="pincodeInput" class="form-control" placeholder="Enter PIN code,Area,latitude and longitude">
                <button class="btn btn-primary" id="searchpincode" value='search'>Search</button>
            </div>
            </div>
<br><br>


<div class="col-md-12 col-xs-12"> 
    <div id="map" style="height: 400px;"></div><br>
    <button class="btn btn-primary" id="saveCoordinates">Save Coordinates</button>
</div>
</div>
</body>
</html>