<!-- START BREADCRUMB -->
<ul class="breadcrumb">
  <li><a href="#">Home</a></li>
  <li><a href="#">Product Banners</a></li>
  <li class="active">Add Product Banner</li>
</ul>
<!-- END BREADCRUMB -->

<!-- PAGE CONTENT WRAPPER -->
<div class="page-content-wrap">
  <div class="row">
    <div class="col-md-12">
      <?php 
      $attributes = array('class' => 'form-horizontal', 'id' => 'validation');
      echo form_open_multipart('admin/register/update_product_banners', $attributes); 
      ?>
        <div class="panel panel-default">
          <div class="panel-heading" style='display:flex;gap:1rem'>
              <a href='<?=base_url();?>admin/register/product_banners'><img src='https://eeggshop.com/es_admin/image/previous.png' style='width:28px'></a>
            <h2 class="panel-title">Add Product Banner</h2>            
          </div>
          <?php if($this->session->flashdata('success') != "") : ?>                
            <div class="alert alert-success" role="alert">
              <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
              <?=$this->session->flashdata('success');?>
            </div>
          <?php endif; ?>
          <div class="panel-body">       
              
              <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Enter Title</label>
                <div class="col-md-6 col-xs-12">                
                  <span class="input-group-addon"><i class="fa fa-pencil"></i></span>
                  <input type="text" class="form-control" name="title" id="title" />
                </div>
              </div>
               <div class="form-group">
              <label for="icon" class="col-md-3 col-xs-12 control-label">Upload Image</label>
              <div class="col-md-6 col-xs-12">
                <div class="">
                  <input type="file" class="fileinput btn-primary" name="icon" id="icon" accept="image/*" />
                  <span style="color:red">Banner Dimensions 360*160</span>
                </div>
              </div>
            </div>
            
            <div class="form-group">
                <label for="state" class="col-md-3 col-xs-12 control-label">Category</label>
                <div class="col-md-6 col-xs-12">                
                  <select name="category" class="form-control" onchange="get_subcategories(this.value)">
					<option value="">-Select-</option>
					<?php foreach($categories as $c){?>
					<option value="<?php echo $c['id'];?>"><?php echo $c['category_name'];?></option>
					<?php } ?>
				  </select>
                </div>
              </div>
              
              <div class="form-group" id="sub_category_dd">
                <label for="state" class="col-md-3 col-xs-12 control-label">Sub Category</label>
                <div class="col-md-6 col-xs-12">                
                  <select name="sub_category" class="form-control" onchange="get_subcat_product(this.value)">
					<option value="">-Select-</option>
				</select>
                </div>
              </div>
              
              <div class="form-group" id="product_dd">
                <label for="state" class="col-md-3 col-xs-12 control-label">Product Name</label>
                <div class="col-md-6 col-xs-12">                
                  <select name="product_id" class="form-control">
					<option value="">-Select-</option>
				</select>
                </div>
              </div>
              
              
              <!--<div class="form-group">-->
              <!--  <label for="title" class="col-md-3 col-xs-12 control-label">Enter Description</label>-->
              <!--  <div class="col-md-6 col-xs-12">                -->
              <!--    <span class="input-group-addon"><i class="fa fa-pencil"></i></span>-->
              <!--    <input type="text" class="form-control" name="description" id="description" />-->
              <!--  </div>-->
              <!--</div>-->

             

          </div>
          <div class="panel-footer">
            <a href="<?=base_url();?>admin/register/product_banners" class="btn btn-primary pull-right" style="margin-left:10px;">Cancel</a>    
            <button type="submit" class="btn btn-primary pull-right" id="btnSubmit">Submit</button>
          </div>
        </div>
      </form>

    </div>
  </div>
</div>
<!-- END PAGE CONTENT WRAPPER -->
<script src="<?php echo base_url(); ?>assets/js/jquery.validate.js"></script>
<script src="<?php echo base_url(); ?>assets/js/jquery-validate-additional-methods.js"></script>
<script>
  $(document).ready(function() { //alert();
      $("#validation").validate({
          rules: {
            // simple rule, converted to {required:true}            
            icon: {
                required : true,
                extension: "pdf|jpg|png|gif|jpeg"
            },
            title: {
                required : true,
            },
            
                     
          },
           messages: {
        
        icon: {
            extension: "Allowed Extensions:pdf|jpg|png|gif|jpeg",
            
        },
    },
          submitHandler: function(form) {
              $("#btnSubmit").prop('disabled', true);
              form.submit();
          }
        });
        
        
        
		   
      
  }); 
  
  function get_subcategories(val)
		   {
			   //alert(val);
			   //exit;
			   $.ajax({
                    url : "<?php echo base_url('admin/register/get_pro_category_sub_dropdown');?>",
                    method : "POST",
                    data : {id: val},
                   // async : true,
                    dataType : 'html',
                    success: function(data){
                         
                    $("#sub_category_dd").html(data);  
                    
                    }
                });
		   }
	
	function get_subcat_product(val)
	{
	    $.ajax({
                    url : "<?php echo base_url('admin/register/get_sub_category_product_dropdown');?>",
                    method : "POST",
                    data : {id: val},
                   // async : true,
                    dataType : 'html',
                    success: function(data){
                         
                    $("#product_dd").html(data);  
                    
                    }
                });
	}
</script>
